#include "stdafx.h"
#include "DIBitmap.h"

using namespace std;

//rbg}bv`悵܂
void CDIBitmap::Draw( int x, int y, CDIBitmap* src )
{
	int w, h;
	POINT src_rb, src_lt, dest_rb, dest_lt;

	w = src->GetWidth();
	h = src->GetHeight();

    //E[̍WZo
    if ( x+w>Width ) {
		src_rb.x = Width - x;
		dest_rb.x = Width;
	}
	else {
		src_rb.x = w;
		dest_rb.x = x + w;
	}

	//[̍WZo
	if ( y+h>Height ) {
		src_rb.y = Height - y;
		dest_rb.y = Height;
	}
	else {
		src_rb.y = h;
		dest_rb.y = y + h;
	}

	//[̍WZo
	if ( x<0 ) {
		src_lt.x = -x;
		dest_lt.x = 0;
	}
	else {
		src_lt.x = 0;
		dest_lt.x = x;
	}

	//[̍WZo
	if ( y<0 ) {
		src_lt.y = -y;
    	dest_lt.y = 0;
	}
	else {
		src_lt.y = 0;
		dest_lt.y = y;
	}


	//rbg}bṽRs[
	DWORD *src_px, *dest_px;
	int src_row, dest_row, src_r, dest_r, i, k;


	//ϐ
	src_px = src->GetBits();
	dest_px = Pixels;
	src_row = src_lt.y;
	dest_row = dest_lt.y;


	//Rs[[v
	for ( ; src_row<src_rb.y && dest_row<dest_rb.y; src_row++, dest_row++ ) {

		src_r = src_row * Width;
		dest_r = dest_row * w;
		i = src_lt.x;
		k = dest_lt.x;

		for ( ; i<src_rb.x && k<dest_rb.x; i++, k++ )
			dest_px[dest_r + k] = src_px[src_r + i];
	}
}
//---------------------------------------------------------------------------

//w肳ꂽfoCXɃrbg}bv`悵܂
void CDIBitmap::StretchBlt( HDC hdest, int x, int y, DWORD dwRop )
{
	StretchDIBits(
		hdest, x, y, Width, Height, 0, 0, Width, Height,
		Pixels, &biBMP, DIB_RGB_COLORS, dwRop);
}
//---------------------------------------------------------------------------

//̈hԂ܂
void CDIBitmap::Clear( DWORD color )
{
	std::fill(Pixels, Pixels + Length, color);
}
//---------------------------------------------------------------------------

//foCXReLXg擾܂
HDC CDIBitmap::GetDC(HWND wnd)
{
	HDC hdc;

	//foCXReLXg̎擾
	ReleaseDC();
	hdc = ::GetDC(wnd);
	hdcBMP = CreateCompatibleDC(hdc);
	::ReleaseDC(wnd, hdc);


	//GDIIuWFNgI
	hbmpOld = (HBITMAP)SelectObject(hdcBMP, hbmpBMP);

	return hdcBMP;
}
//---------------------------------------------------------------------------

//foCXReLXgJ܂
void CDIBitmap::ReleaseDC()
{
	//GDIIuWFNg̊J
	if ( hdcBMP!=NULL ) {

		SelectObject(hdcBMP, hbmpOld);
		DeleteDC(hdcBMP);

		hdcBMP = NULL;
		hbmpOld = NULL;
	}
}
//---------------------------------------------------------------------------

//DIBSection𐶐܂
void CDIBitmap::SetSize( int w, int h )
{
	ZeroMemory(&biBMP, sizeof(biBMP));

	Width = w;
	Height = h;
	Length = w * h;
	
	biBMP.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	biBMP.bmiHeader.biBitCount = 32;
	biBMP.bmiHeader.biPlanes = 1;
	biBMP.bmiHeader.biWidth = w;
	biBMP.bmiHeader.biHeight = -h;

	DeleteObject(hbmpBMP);
	hbmpBMP = CreateDIBSection(NULL, &biBMP, DIB_RGB_COLORS, (void**)(&Pixels), NULL, 0);


	//Ɏsꍇ̓p[^O
	if ( hbmpBMP==NULL ) {

		Length = 0;
		Width = 0;
		Height = 0;
    }
}
//---------------------------------------------------------------------------

//RXgN^
CDIBitmap::CDIBitmap()
{
	SetSize(1,1);
	hbmpOld = NULL;
	hdcBMP = NULL;
}
//---------------------------------------------------------------------------

//fXgN^
CDIBitmap::~CDIBitmap()
{
	ReleaseDC();
    DeleteObject(hbmpBMP);
}
//---------------------------------------------------------------------------

//rbg}bvt@Cɏo͂܂
void CDIBitmap::SaveToFile( tstring path )
{
	int k;
	BITMAPFILEHEADER bmpfh;
	BITMAPINFOHEADER bmpih;


	//t@Cwb_̐
	ZeroMemory(&bmpfh, sizeof(BITMAPFILEHEADER));
	bmpfh.bfType = 0x4d42;
	bmpfh.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + Length * sizeof(DWORD);
	bmpfh.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);


	//wb_̐
	ZeroMemory(&bmpih, sizeof(BITMAPINFOHEADER));
	bmpih.biSize = sizeof(BITMAPINFOHEADER);
	bmpih.biWidth = Width;
	bmpih.biHeight = Height;
	bmpih.biPlanes = 1;
	bmpih.biBitCount = 32;
	bmpih.biCompression = BI_RGB;


	//wb_o
	ofstream of(path.c_str(), ios::out | ios::binary);
	of.write((char*)&bmpfh, sizeof(BITMAPFILEHEADER));
	of.write((char*)&bmpih, sizeof(BITMAPINFOHEADER));


	//摜o
	for ( int i=Height-1; i>=0; i-- ) {

    	k = i * Width;
    	of.write((char*)(Pixels + k), Width * sizeof(DWORD));
	}
	of.close(); 
}
//---------------------------------------------------------------------------
