#pragma once

//---------------------------------------------------------------------------
//
//	CListViewPluspACeC^[tFCX
//
//---------------------------------------------------------------------------
const int EDIT_DISABLED	= -1;
class IListItem
{
public:
	//fXgN^
	virtual ~IListItem(){}

	//eANZX\bh
	virtual LPCTSTR GetText(int col) const { return NULL; }
	virtual void SetText(int col, LPCTSTR tstr) {}

	virtual int GetImage() const { return -1; }
	virtual void SetImage(int img) {}

	virtual int GetEditType(int col) const { return EDIT_DISABLED; }
	virtual void SetEditType(int col, int type) {}
};

//---------------------------------------------------------------------------
//
//	CListViewPlusWACe
//
//---------------------------------------------------------------------------
template<unsigned int _Column, int _DefEditType=EDIT_DISABLED>
class CBasicListItem : public IListItem
{
private:
	int		mImage;
	int		mEditType[_Column];

	WTL::CString	mText[_Column];

public:
	// RXgN^
	CBasicListItem()
	{
		mImage = -1;
		std::fill(mEditType, mEditType+_Column, _DefEditType);
	}

	// eLXg̎擾
	LPCTSTR GetText(int col) const
	{
		return (col>=0 && col<_Column) ? mText[col] : (LPCTSTR)NULL;
	}
	// eLXg̐ݒ
	void SetText(int col, LPCTSTR tstr)
	{
		if (col>=0 && col<_Column)
			mText[col] = tstr;
	}

	// C[W̎擾
	int GetImage() const { return mImage; }
	// C[W̐ݒ
	void SetImage(int img) { mImage = img; }
	// ҏW@̎擾
	int GetEditType(int col) const
	{
		return (col>=0 && col<_Column) ? mEditType[col] : EDIT_DISABLED;
	}
	// ҏW@̐ݒ
	void SetEditType(int col, int type)
	{
		if ( col>=0 && col<_Column )
			mEditType[col] = type;
	}
};

typedef CBasicListItem<2>	CBasicListItem2;
typedef CBasicListItem<3>	CBasicListItem3;
typedef CBasicListItem<4>	CBasicListItem4;
