#include "stdafx.h"
#include "MatchingElem.h"
#include "MelonDocument.h"
#include "MelonSweep.h"
#include "SmithStyle.h"
#include "VersionDialog.h"
#include "MainForm.h"
//---------------------------------------------------------------------------
//
//	OCt[
//
//---------------------------------------------------------------------------

// t@CJ
void CMainFrame::OnFileOpen(UINT uNotifyCode, int nID, CWindow wndCtl)
{
	// _CAO𐶐
	CFileDialog dlg(TRUE, _T("s*p"), NULL, OFN_HIDEREADONLY | OFN_CREATEPROMPT,
		_T("Touch stone file (*.snp)\0*.s*p\0ׂẴt@C (*.*)\0*.*\0\0"));

	if ( dlg.DoModal()==IDOK ) {

		// N|[gf[^ƃfUC𐶐
		WTL::CString name(dlg.m_szFileName);
		CMelonDesign* design = new CMelonDesign(new CNPortTerminal(name, 0));

		// fUC
		int pos = name.ReverseFind(_T('\\'));
		name.Delete(0, pos + 1);
		design->SetDesignName(name);

		// fUChLgɒǉčĕ`
		GetManager()->GetDocument()->AddDesign(design);
		GetManager()->UpdateControl(
			CTRL_MATCHLIST |CTRL_SWEEPLIST |CTRL_MARKERLIST |CTRL_DESIGNLIST |CTRL_SMITHCHART);
		GetManager()->UpdatePropList(design->Sweep(0));
	}
}
//---------------------------------------------------------------------------

// EMFt@Co͂܂
void CMainFrame::OnExportEmf(UINT uNotifyCode, int nID, CWindow wndCtl)
{
	// _CAO𐶐
	CFileDialog dlg(FALSE, _T("emf"), NULL, OFN_OVERWRITEPROMPT,
		_T("g^t@C (*.emf)\0*.emf\0ׂẴt@C (*.*)\0*.*\0\0"));

	if ( dlg.DoModal()==IDOK ) {

		// fUC𐶐
		CDIBitmap* bmp = mSmithChart.GetCanvas();
		Gdiplus::Metafile meta(dlg.m_szFileName, bmp->GetDC(mSmithChart));
		Gdiplus::Graphics g( &meta );
		GetManager()->DrawSmithChart(g);

		bmp->ReleaseDC();
	}
}
//---------------------------------------------------------------------------

// VK쐬R}h
void CMainFrame::OnNewDocument(UINT uNotifyCode, int nID, CWindow wndCtl)
{
	// fUC폜āAEChEXV܂
	GetManager()->GetDocument()->Clear();
	GetManager()->UpdateControl(
		CTRL_MATCHLIST |CTRL_SWEEPLIST |CTRL_MARKERLIST |CTRL_DESIGNLIST |CTRL_SMITHCHART);
	GetManager()->UpdatePropList(NULL);
}
//---------------------------------------------------------------------------

// o[W\
void CMainFrame::OnVersionInfo(UINT uNotifyCode, int nID, CWindow wndCtl)
{
	CVersionDialog dlg;
	dlg.DoModal();
}
//---------------------------------------------------------------------------

// fUC폜܂
void CMainFrame::OnDelDesign(UINT uNotifyCode, int nID, CWindow wndCtl)
{
	CMelonDesign* design = GetManager()->GetDesign();

	// ANeBuȃfUC`FbN
	if ( design!=NULL ) {

		// fUC폜āA\XV܂B
		CMelonDocument* doc = GetManager()->GetDocument();
		doc->DelDesign( doc->GetActiveIndex() );
		GetManager()->UpdateControl(
			CTRL_MATCHLIST |CTRL_SWEEPLIST |CTRL_MARKERLIST |CTRL_DESIGNLIST |CTRL_SMITHCHART);

		design = GetManager()->GetDesign();
		GetManager()->UpdatePropList( (design!=NULL) ? design->Sweep(0) : NULL );
	}
}
//---------------------------------------------------------------------------

// AChnh
BOOL CMainFrame::OnIdle()
{
	GetManager()->OnIdle();
	return FALSE;
}
//---------------------------------------------------------------------------

// bZ[WtB^
BOOL CMainFrame::PreTranslateMessage(MSG *pMsg)
{
	if ( !mAcc.IsNull() && mAcc.TranslateAccelerator(m_hWnd, pMsg) )
		return TRUE;

	if ( CFrameWindowImpl<CMainFrame>::PreTranslateMessage(pMsg) )
		return TRUE;

	if ( mPropForm.PreTranslateMessage(pMsg) )
		return TRUE;

	return mSmithChart.PreTranslateMessage(pMsg);
}
//---------------------------------------------------------------------------

// EChE
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	// 傫ACRݒ
	HICON hIcon = AtlLoadIconImage(IDR_MAINFRAME, LR_DEFAULTCOLOR,
		::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON));
	SetIcon(hIcon, TRUE);

	// ANZ[^̓ǂݍ
	mAcc.LoadAccelerators(IDR_MAINFRAME);

	// XvbgEChE̍쐬
	mVSplitter.Create(m_hWnd, rcDefault, NULL,
		WS_CHILD| WS_VISIBLE| WS_CLIPCHILDREN| WS_CLIPSIBLINGS);
	mVSplitter.SetSplitterExtendedStyle(SPLIT_RIGHTALIGNED);

	mHSplitter.Create(mVSplitter, rcDefault, NULL,
		WS_CHILD| WS_VISIBLE| WS_CLIPCHILDREN| WS_CLIPSIBLINGS);
	mHSplitter.SetSplitterExtendedStyle(SPLIT_BOTTOMALIGNED);
	

	// r[쐬
	mPropForm.Create(mHSplitter);
	mTabView.Create(mHSplitter, rcDefault, NULL,
		WS_CHILD |WS_VISIBLE |WS_CLIPCHILDREN |WS_CLIPSIBLINGS);
	mSmithChart.Create(mVSplitter, rcDefault, NULL,
		WS_CHILD |WS_VISIBLE |WS_CLIPCHILDREN |WS_CLIPSIBLINGS, WS_EX_CLIENTEDGE);
	mMatchingList.Create(mTabView, rcDefault, NULL,
		WS_CHILD |WS_VISIBLE |WS_CLIPCHILDREN |WS_CLIPSIBLINGS |WS_BORDER |LVS_OWNERDATA |LVS_REPORT |LVS_SINGLESEL);
	mSweepList.Create(mTabView, rcDefault, NULL,
		WS_CHILD |WS_VISIBLE |WS_CLIPCHILDREN |WS_CLIPSIBLINGS |WS_BORDER |LVS_OWNERDATA |LVS_REPORT |LVS_SINGLESEL);
	mMarkerList.Create(mTabView, rcDefault, NULL,
		WS_CHILD |WS_VISIBLE |WS_CLIPCHILDREN |WS_CLIPSIBLINGS |WS_BORDER |LVS_OWNERDATA |LVS_REPORT |LVS_SINGLESEL);
	mSmithStyles.Create(mTabView, rcDefault, NULL,
		WS_CHILD |WS_VISIBLE |WS_CLIPCHILDREN |WS_CLIPSIBLINGS |WS_BORDER |LVS_OWNERDATA |LVS_REPORT |LVS_SINGLESEL);


	// yC̐ݒ
	m_hWndClient = mVSplitter;
	mVSplitter.SetSplitterPane(SPLIT_PANE_LEFT, mSmithChart);
	mVSplitter.SetSplitterPane(SPLIT_PANE_RIGHT, mHSplitter);
	mHSplitter.SetSplitterPane(SPLIT_PANE_TOP, mTabView);
	mHSplitter.SetSplitterPane(SPLIT_PANE_BOTTOM, mPropForm);
	
	UpdateLayout();
	mVSplitter.SetSplitterPos(420);
	mHSplitter.SetSplitterPos(150);


	// eR|[lgɃf[^ݒ
	mTabView.AddPage(mMatchingList, _T("Match"));
	initMatchingList();
	mTabView.AddPage(mSweepList, _T("Sweep"));
	initSweepList();
	mTabView.AddPage(mMarkerList, _T("Marker"));
	initMarkerList();
	mTabView.AddPage(mSmithStyles, _T("Styles"));
	initSmithStyles();

	// bZ[WtB^ǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

	return 0;
}
//---------------------------------------------------------------------------

// HXg܂
void CMainFrame::initMatchingList()
{
	// rbg}bvC[WXg쐬
	CBitmap bmp;
	bmp.LoadBitmap(IDB_COMPIMAGE);
	CImageList il;
	il.Create(16, 16, ILC_COLOR8 | ILC_MASK, 8, 1);
	il.Add(bmp);

	// Xgr[
	CRect rect;
	mMatchingList.GetClientRect(&rect);
	mMatchingList.SetExtendedListViewStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	mMatchingList.SetImageList(il, LVSIL_SMALL);
	mMatchingList.SetFont(GetFont(), false);

	// ҏWpGfBbgƃR{{bNX̍쐬
	CLabelEdit* label_edit = mMatchingList.AddEditor<CLabelEdit>(EDIT_TEXTBOX);
	CComboEdit* combo_edit = mMatchingList.AddEditor<CComboEdit>(EDIT_COMPLIST);
	combo_edit->SetImageList(il);
	combo_edit->AddItem(_T("shunt L")	, COMP_SHUNTIND,	COMP_SHUNTIND,	0);
	combo_edit->AddItem(_T("cascade L")	, COMP_CASCADEIND,	COMP_CASCADEIND,0);
	combo_edit->AddItem(_T("shunt C")	, COMP_SHUNTCAP,	COMP_SHUNTCAP,	0);
	combo_edit->AddItem(_T("cascade C")	, COMP_CASCADECAP,	COMP_CASCADECAP,0);
	combo_edit->AddItem(_T("trans line"), COMP_TRLINE,		COMP_TRLINE,	0);
	combo_edit->AddItem(_T("shunt stub"), COMP_SHUNTSTUB,	COMP_SHUNTSTUB,	0);
	combo_edit->AddItem(_T("open stub")	, COMP_OPENSTUB,	COMP_OPENSTUB,	0);

	// ڂ̐ݒ
	mMatchingList.InsertColumn(0, _T("item"),	LVCFMT_LEFT, 0.5*rect.Width());
	mMatchingList.InsertColumn(1, _T("value"),	LVCFMT_LEFT, 0.25*rect.Width());
	mMatchingList.InsertColumn(2, _T("unit"),	LVCFMT_LEFT, 0.25*rect.Width());
//	add_testdata();
}
//---------------------------------------------------------------------------

// gXg܂
void CMainFrame::initSweepList()
{
	// ̃C[WXg쐬
	CImageList il;
	il.Create(1, 16, ILC_COLOR8 | ILC_MASK, 0, 0);

	// Xgr[
	CRect rect;
	mSweepList.GetClientRect(&rect);
	mSweepList.SetExtendedListViewStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	mSweepList.SetImageList(il, LVSIL_SMALL);
	mSweepList.SetFont(GetFont(), false);
	
	// ҏWpGfBbg̍쐬
	CLabelEdit* label_edit = mSweepList.AddEditor<CLabelEdit>(EDIT_TEXTBOX);
	
	// ڂ̐ݒ
	mSweepList.InsertColumn(0, _T("item"),	LVCFMT_LEFT, 0.25*rect.Width());
	mSweepList.InsertColumn(1, _T("start"),	LVCFMT_LEFT, 0.25*rect.Width());
	mSweepList.InsertColumn(2, _T("stop"),	LVCFMT_LEFT, 0.25*rect.Width());
	mSweepList.InsertColumn(3, _T("unit"),	LVCFMT_LEFT, 0.25*rect.Width());
}
//---------------------------------------------------------------------------

// f[^}[J[Xg܂
void CMainFrame::initMarkerList()
{
	// ̃C[WXg쐬
	CImageList il;
	il.Create(1, 16, ILC_COLOR8 | ILC_MASK, 0, 0);

	// Xgr[
	CRect rect;
	mMarkerList.GetClientRect(&rect);
	mMarkerList.SetExtendedListViewStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	mMarkerList.SetImageList(il, LVSIL_SMALL);
	mMarkerList.SetFont(GetFont(), false);
	
	// ҏWpGfBbg̍쐬
	CLabelEdit* label_edit = mMarkerList.AddEditor<CLabelEdit>(EDIT_TEXTBOX);
	
	// ڂ̐ݒ
	mMarkerList.InsertColumn(0, _T("marker"),	LVCFMT_LEFT, 0.25*rect.Width());
	mMarkerList.InsertColumn(1, _T("freq"),		LVCFMT_LEFT, 0.25*rect.Width());
	mMarkerList.InsertColumn(2, _T("unit"),		LVCFMT_LEFT, 0.25*rect.Width());
}
//---------------------------------------------------------------------------

// vpeBXg܂
void CMainFrame::initSmithStyles()
{
	// ̃C[WXg쐬
	CImageList il;
	il.Create(1, 16, ILC_COLOR8 | ILC_MASK, 0, 0);

	// Xgr[
	CRect rect;
	mSmithStyles.GetClientRect(&rect);
	mSmithStyles.SetExtendedListViewStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	mSmithStyles.SetImageList(il, LVSIL_SMALL);
	mSmithStyles.SetFont(GetFont(), false);
	
	// ҏWpGfBbg̍쐬
	mSmithStyles.AddEditor<CLabelEdit>(EDIT_TEXTBOX);
	mSmithStyles.AddEditor<CColorEdit>(EDIT_COLORDLG);
	mSmithStyles.InsertColumn(0, _T("item"),	LVCFMT_LEFT, 0.25*rect.Width());
	mSmithStyles.InsertColumn(1, _T("value"),	LVCFMT_LEFT, 0.25*rect.Width());
	mSmithStyles.InsertColumn(2, _T("unit"),	LVCFMT_LEFT, 0.25*rect.Width());

	// CX^XƃN
	mSmithStyles.SetProperties( GetManager()->GetStyle() );
}
//---------------------------------------------------------------------------

// eXgf[^}܂
void CMainFrame::add_testdata()
{
	CBasicListItem3 item;
	item.SetEditType(0, 1);
	item.SetEditType(1, 0);

	unsigned int i;
	tstringstream strm;
	for ( i=0; i<10; i++ ) {

		strm.str(_T(""));
		strm << i;

		switch ( i%3 ) {
			case 0:
				item.SetText(0, _T("shunt L"));
				item.SetText(1, strm.str().c_str());
				item.SetText(2, _T("nH"));
				item.SetImage(0);
				mMatchingList.AddListItem(item);
				break;

			case 1:
				item.SetText(0, _T("cascade L"));
				item.SetText(1, strm.str().c_str());
				item.SetText(2, _T("nH"));
				item.SetImage(1);
				mMatchingList.AddListItem(item);
				break;

			case 2:
				item.SetText(0, _T("shunt C"));
				item.SetText(1, strm.str().c_str());
				item.SetText(2, _T("pF"));
				item.SetImage(2);
				mMatchingList.AddListItem(item);
				break;
		}
	}
}
//---------------------------------------------------------------------------

// EChEj
void CMainFrame::OnDestroy()
{
	// bZ[W[v폜
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->RemoveMessageFilter(this);
	pLoop->RemoveIdleHandler(this);
	SetMsgHandled(false);
}
//---------------------------------------------------------------------------

