#pragma once
#include "resource.h"
#include "PropertyForm.h"
#include "SmithWindow.h"
#include "MelonManager.h"
#include "MyListView.h"

//---------------------------------------------------------------------------
//
//	OCt[
//
//---------------------------------------------------------------------------
class CMainFrame :
	public CFrameWindowImpl<CMainFrame>,
	public CMessageFilter,
	public CIdleHandler,
	public CManagerAccess
{
private:
	void add_testdata();
	void initMatchingList();
	void initSweepList();
	void initMarkerList();
	void initSmithStyles();

public:
    // EBhENXAʃ\[XIDAX^CAwiFo^
	DECLARE_FRAME_WND_CLASS_EX(_T("MelonFrame"), IDR_MAINFRAME,
		CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, COLOR_WINDOW)

	// ANZ[^
	CAccelerator		mAcc;

	// eRg[
	CSplitterWindow		mVSplitter;
	CHorSplitterWindow	mHSplitter;
	CTabView			mTabView;
	CPropertyForm		mPropForm;
	CSmithWindow		mSmithChart;

	CMatchListView		mMatchingList;
	CSweepListView		mSweepList;
	CMarkerListView		mMarkerList;
	CPropListView		mSmithStyles;


	// bZ[W}bv
    BEGIN_MSG_MAP(CMainFrame)
		MSG_WM_CREATE(OnCreate)
        MSG_WM_DESTROY(OnDestroy)
		COMMAND_ID_HANDLER_EX(ID_APP_OPEN, OnFileOpen)
		COMMAND_ID_HANDLER_EX(ID_APP_NEW, OnNewDocument)
		COMMAND_ID_HANDLER_EX(ID_APP_VER, OnVersionInfo)
		COMMAND_ID_HANDLER_EX(ID_DELDESIGN, OnDelDesign)
		COMMAND_ID_HANDLER_EX(ID_EXPORTEMF, OnExportEmf)
		CHAIN_MSG_MAP(CFrameWindowImpl<CMainFrame>)
		REFLECT_NOTIFICATIONS_HWND_FILTERED(mSweepList)
		REFLECT_NOTIFICATIONS_HWND_FILTERED(mMatchingList)
		REFLECT_NOTIFICATIONS_HWND_FILTERED(mMarkerList)
		REFLECT_NOTIFICATIONS_HWND_FILTERED(mSmithStyles)
    END_MSG_MAP()

	// eCxgnh
	BOOL PreTranslateMessage(MSG *pMsg);
	BOOL OnIdle();
	int OnCreate(LPCREATESTRUCT lpCreateStruct);
	void OnDestroy();
	void OnFileOpen(UINT uNotifyCode, int nID, CWindow wndCtl);
	void OnNewDocument(UINT uNotifyCode, int nID, CWindow wndCtl);
	void OnExportEmf(UINT uNotifyCode, int nID, CWindow wndCtl);
	void OnVersionInfo(UINT uNotifyCode, int nID, CWindow wndCtl);
	void OnDelDesign(UINT uNotifyCode, int nID, CWindow wndCtl);
};
