#include "stdafx.h"
#include "MyListView.h"
#include "MatchingElem.h"

//---------------------------------------------------------------------------
//
//	NPortf[^I[
//
//---------------------------------------------------------------------------

// ̓Cs[_XvZ܂
void CNPortTerminal::Update()
{
	complex<double> ident(1.0), s;
	CNPortData::const_iterator it;

	// dˌWo܂
	mReturn.clear();
	for ( it=mNPort.begin(); it!=mNPort.end(); it++ ) {
		mReturn.push_back( (*it)(mPort, mPort) );
	}
}
//---------------------------------------------------------------------------

// p[^ݒ肵܂
void CNPortTerminal::SetParam(IListItem& item)
{
	tstringstream tstr( item.GetText(1) );

	// ^[Qbg̃|[gݒ肵܂
	int port;
	tstr >> port;
	if ( !tstr.fail() && port>=0 && port<mNPort.NumPorts() ) {
		mPort = port;
		Update();
	}

	// \̍XV
	GetParam(item);
}
//---------------------------------------------------------------------------

// p[^擾܂
void CNPortTerminal::GetParam(IListItem& item)
{
	// ڂƃACR̐ݒ
	item.SetImage(COMP_NPORTTERM);
	item.SetText(0, _T("NPort data"));
	item.SetText(2, _T("port"));
	item.SetEditType(0, EDIT_DISABLED);
	item.SetEditType(1, EDIT_TEXTBOX);
	item.SetEditType(2, EDIT_DISABLED);
	
	// p[^̐ݒ
	tstringstream tstr;
	tstr << mPort;
	item.SetText(1, tstr.str().c_str());
}
//---------------------------------------------------------------------------

// RXgN^
CNPortTerminal::CNPortTerminal(const CNPortData& snp, int port)
	: CMatchingElem(SolutionPtr())
{
	mPort = (port>=0 && port<snp.NumPorts()) ? port : 0;
	mNPort = snp;
	mSolution = mNPort.GetSolution();
	Update();
}
//---------------------------------------------------------------------------

// t@C̃RXgN^
CNPortTerminal::CNPortTerminal(const WTL::CString& nport_file, int port)
	: CMatchingElem(SolutionPtr()), mNPort(nport_file)
{
	mNPort.ToSmatrix();
	mPort = (port>=0 && port<mNPort.NumPorts()) ? port : 0;
	mSolution = mNPort.GetSolution();
	Update();
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	}b`OGgNX
//
//---------------------------------------------------------------------------

// freq傫lԂ܂
CMatchingElem::const_iterator CMatchingElem::upper_bound(double freq)
{
	CSolution::const_iterator it = std::upper_bound(mSolution->begin(), mSolution->end(), freq);
	return begin() + distance((CSolution::const_iterator)mSolution->begin(), it);
}
//---------------------------------------------------------------------------

// freq菬lԂ܂
CMatchingElem::const_iterator CMatchingElem::lower_bound(double freq)
{
	CSolution::const_iterator it = std::lower_bound(mSolution->begin(), mSolution->end(), freq);
	return begin() + distance((CSolution::const_iterator)mSolution->begin(), it);
}
//---------------------------------------------------------------------------

// freqƈvf[^Ԃ܂
CMatchingElem::const_iterator CMatchingElem::find(double freq)
{
	CSolution::const_iterator it = std::find(mSolution->begin(), mSolution->end(), freq);
	return begin() + distance((CSolution::const_iterator)mSolution->begin(), it);
}
//---------------------------------------------------------------------------

// `F[ݒ肵܂
void CMatchingElem::SetChain(CMatchingElem* chain)
{
	if ( chain!=NULL ) {
		mChain = chain;
		mSolution = mChain->GetSolution();
	}
}
//---------------------------------------------------------------------------

// RXgN^
CMatchingElem::CMatchingElem(SolutionPtr sol, CMatchingElem* chain)
{
	mSolution = sol;
	mChain = chain;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	ėpW萔fq
//
//---------------------------------------------------------------------------

// p[^ݒ肵܂
void CLumpedElem::SetParam(IListItem& item)
{
	GetVariable(item, mValue, mUnit);
	GetParam(item);
}
//---------------------------------------------------------------------------

// `F[ݒ肵܂
void CLumpedElem::SetChain(CMatchingElem* chain)
{
	CMatchingElem::SetChain(chain);
}
//---------------------------------------------------------------------------

// RXgN^
CLumpedElem::CLumpedElem(CMatchingElem *chain, double val)
	: CMatchingElem(SolutionPtr()), mValue(val)
{
	if ( chain!=NULL ) SetChain(chain);
	mUnit.AutoUnit(val);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	C_N^
//
//---------------------------------------------------------------------------

// p[^̏o
void CCascadedInd::GetParam(IListItem& item)
{
	SetItem(item, mValue, mUnit, _T("H"));
	item.SetText(0, _T("cascade L"));
	item.SetImage(COMP_CASCADEIND);
	item.SetEditType(0, EDIT_COMPLIST);
}
//---------------------------------------------------------------------------

// S11XV܂
void CCascadedInd::Update()
{
	if ( mChain!=NULL ) {
		
		CSolution::const_iterator f = mSolution->begin();
		CMatchingElem::const_iterator it;
		complex<double> sp1, sm1, z0(50.0), zc, temp;

		// dˌWvZ܂
		mReturn.clear();
		for ( it=mChain->begin(); it!=mChain->end(); it++, f++ ) {

			sp1 = (complex<double>(1.0) + *it) * z0;
			sm1 = complex<double>(1.0) - *it;

			zc.real( 0.0 );
			zc.imag( 2.0 * M_PI * (*f) * mValue );

			temp = sp1 + sm1 * (zc - z0);
			temp /= sp1 + sm1 * (zc + z0);

			mReturn.push_back(temp);
		}
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	LpV^
//
//---------------------------------------------------------------------------

// p[^̏o
void CCascadedCap::GetParam(IListItem& item)
{
	SetItem(item, mValue, mUnit, _T("F"));
	item.SetText(0, _T("cascade C"));
	item.SetImage(COMP_CASCADECAP);
	item.SetEditType(0, EDIT_COMPLIST);
}
//---------------------------------------------------------------------------

// S11XV܂
void CCascadedCap::Update()
{
	if ( mChain!=NULL ) {
		
		CSolution::const_iterator f = mSolution->begin();
		CMatchingElem::const_iterator it;
		complex<double> sp1, sm1, z0(50.0), zc, temp;

		// dˌWvZ܂
		mReturn.clear();
		for ( it=mChain->begin(); it!=mChain->end(); it++, f++ ) {

			sp1 = (complex<double>(1.0) + *it) * z0;
			sm1 = complex<double>(1.0) - *it;

			zc.real( 0.0 );
			zc.imag( -1.0 / (2.0 * M_PI * (*f) * mValue) );

			temp = sp1 + sm1 * (zc - z0);
			temp /= sp1 + sm1 * (zc + z0);

			mReturn.push_back(temp);
		}
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	LpV^
//
//---------------------------------------------------------------------------

// p[^̏o
void CShuntedCap::GetParam(IListItem& item)
{
	SetItem(item, mValue, mUnit, _T("F"));
	item.SetText(0, _T("shunt C"));
	item.SetImage(COMP_SHUNTCAP);
	item.SetEditType(0, EDIT_COMPLIST);
}
//---------------------------------------------------------------------------

// S11XV܂
void CShuntedCap::Update()
{
	if ( mChain!=NULL ) {
		
		CSolution::const_iterator f = mSolution->begin();
		CMatchingElem::const_iterator it;
		complex<double> sp1, z0(50.0), ys, temp;

		// dˌWvZ܂
		mReturn.clear();
		for ( it=mChain->begin(); it!=mChain->end(); it++, f++ ) {

			ys.real( 0.0 );
			ys.imag( 2.0 * M_PI * (*f) * mValue );

			sp1 = (complex<double>(1.0) + *it) * z0 * ys;

			temp = 2.0 * (*it) - sp1;
			temp /= 2.0 + sp1;

			mReturn.push_back(temp);
		}
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	C_N^
//
//---------------------------------------------------------------------------

// p[^̏o
void CShuntedInd::GetParam(IListItem& item)
{
	SetItem(item, mValue, mUnit, _T("H"));
	item.SetText(0, _T("shunt L"));
	item.SetImage(COMP_SHUNTIND);
	item.SetEditType(0, EDIT_COMPLIST);
}
//---------------------------------------------------------------------------

// S11XV܂
void CShuntedInd::Update()
{
	if ( mChain!=NULL ) {
		
		CSolution::const_iterator f = mSolution->begin();
		CMatchingElem::const_iterator it;
		complex<double> sp1, z0(50.0), ys, temp;

		// dˌWvZ܂
		mReturn.clear();
		for ( it=mChain->begin(); it!=mChain->end(); it++, f++ ) {

			ys.real( 0.0 );
			ys.imag( -1.0 / (2.0 * M_PI * (*f) * mValue) );

			sp1 = (complex<double>(1.0) + *it) * z0 * ys;

			temp = 2.0 * (*it) - sp1;
			temp /= 2.0 + sp1;

			mReturn.push_back(temp);
		}
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	ėpz萔fq
//
//---------------------------------------------------------------------------

// p[^ݒ肵܂
void CDistributedElem::SetParam(IListItem& item)
{
	GetVariable(item, mELength);
	GetParam(item);
}
//---------------------------------------------------------------------------

// vpeBݒ肵܂
void CDistributedElem::SetProperty(int index, IListItem& item)
{
	// w肳ꂽp[^XV܂
	switch ( index ) {
		
		// dC̐ݒ
		case 0:
			GetVariable(item, mELength);
			break;

		// g̐ݒ
		case 1:
			GetVariable(item, mFreq, mFUnit);
			break;

		// Cs[_X̐ݒ
		case 2:
			GetVariable(item, mImpedance);
			break;
	}

	// \XV
	GetProperty(index, item);
}
//---------------------------------------------------------------------------

// vpeB擾܂
void CDistributedElem::GetProperty(int index, IListItem& item)
{
	// w肳ꂽp[^ݒ肵܂
	switch ( index ) {

		// dC\
		case 0:
			item.SetText(0, _T("ELength"));
			SetItem(item, mELength);
			item.SetText(2, _T("deg"));
			break;

		// g\
		case 1:
			item.SetText(0, _T("Freq"));
			SetItem(item, mFreq, mFUnit, _T("Hz"));
			break;

		// Cs[_X\
		case 2:
			item.SetText(0, _T("Z"));
			SetItem(item, mImpedance);
			item.SetText(2, _T("Ohm"));
			break;
	}
}
//---------------------------------------------------------------------------

// `F[ݒ肵܂
void CDistributedElem::SetChain(CMatchingElem* chain)
{
	CMatchingElem::SetChain(chain);
}
//---------------------------------------------------------------------------

// RXgN^
CDistributedElem::CDistributedElem(CMatchingElem *chain)
	: CMatchingElem(SolutionPtr())
{
	if ( chain!=NULL ) SetChain(chain);
	
	mFreq = 1e9;
	mFUnit.AutoUnit(mFreq);
	mImpedance = 50.0;
	mELength = 90.0;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	I[vX^u
//
//---------------------------------------------------------------------------

// p[^擾܂
void COpenStub::GetParam(IListItem& item)
{
	SetItem(item, mELength);
	item.SetText(0, _T("open stub"));
	item.SetText(2, _T("deg"));
	item.SetImage(COMP_OPENSTUB);
	item.SetEditType(0, EDIT_COMPLIST);
}
//---------------------------------------------------------------------------

// S11XV܂
void COpenStub::Update()
{
	if ( mChain!=NULL ) {
		
		CSolution::const_iterator f = mSolution->begin();
		CMatchingElem::const_iterator it;
		complex<double> sp1, z0(50.0), ys, temp;
		double rad;

		// dˌWvZ܂
		mReturn.clear();
		for ( it=mChain->begin(); it!=mChain->end(); it++, f++ ) {

			rad = M_PI * mELength * (*f) / (mFreq * 180.0);
			ys.real( 0.0 );
			ys.imag(tan(rad) / mImpedance);

			sp1 = (complex<double>(1.0) + *it) * z0 * ys;

			temp = 2.0 * (*it) - sp1;
			temp /= 2.0 + sp1;

			mReturn.push_back(temp);
		}
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	ZX^u
//
//---------------------------------------------------------------------------

// p[^擾܂
void CShuntStub::GetParam(IListItem& item)
{
	SetItem(item, mELength);
	item.SetText(0, _T("shunt stub"));
	item.SetText(2, _T("deg"));
	item.SetImage(COMP_SHUNTSTUB);
	item.SetEditType(0, EDIT_COMPLIST);
}
//---------------------------------------------------------------------------

// S11XV܂
void CShuntStub::Update()
{
	if ( mChain!=NULL ) {
		
		CSolution::const_iterator f = mSolution->begin();
		CMatchingElem::const_iterator it;
		complex<double> sp1, z0(50.0), ys, temp;
		double rad;

		// dˌWvZ܂
		mReturn.clear();
		for ( it=mChain->begin(); it!=mChain->end(); it++, f++ ) {

			rad = M_PI * mELength * (*f) / (mFreq * 180.0);
			ys.real( 0.0 );
			ys.imag(-1.0 / (mImpedance * tan(rad)));

			sp1 = (complex<double>(1.0) + *it) * z0 * ys;

			temp = 2.0 * (*it) - sp1;
			temp /= 2.0 + sp1;

			mReturn.push_back(temp);
		}
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	`H
//
//---------------------------------------------------------------------------

// p[^擾܂
void CTransmissionLine::GetParam(IListItem& item)
{
	SetItem(item, mELength);
	item.SetText(0, _T("trans line"));
	item.SetText(2, _T("deg"));
	item.SetImage(COMP_TRLINE);
	item.SetEditType(0, EDIT_COMPLIST);
}
//---------------------------------------------------------------------------

// S11XV܂
void CTransmissionLine::Update()
{
	if ( mChain!=NULL ) {
		
		CSolution::const_iterator f = mSolution->begin();
		CMatchingElem::const_iterator it;
		complex<double> z1zx, z0zx, temp;
		double tan_rad, z1z1(mImpedance * mImpedance);

		// dˌWvZ܂
		mReturn.clear();
		for ( it=mChain->begin(); it!=mChain->end(); it++, f++ ) {

			// ̓Cs[_Xɕϊ
			z1zx = complex<double>(1.0) + (*it);
			z1zx /= complex<double>(1.0) - (*it);
			z0zx = 50.0 * 50.0 * z1zx;
			z1zx = mImpedance * 50.0 * z1zx;

			// ^WFg̍vZ
			tan_rad = M_PI * mELength * (*f) / (mFreq * 180.0);
			tan_rad = tan(tan_rad);

			// dˌWZo
			temp = z1zx - complex<double>(50.0*mImpedance) - complex<double>(0,tan_rad)*(z0zx - z1z1);
			temp /= z1zx + complex<double>(50.0*mImpedance) + complex<double>(0,tan_rad)*(z0zx + z1z1);

			mReturn.push_back(temp);
		}
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	t@Ng\bh
//
//---------------------------------------------------------------------------
/*
#define COMP_SHUNTIND		0
#define COMP_CASCADEIND		1
#define COMP_SHUNTCAP		2
#define COMP_CASCADECAP		3
#define COMP_NPORTTERM		4
#define COMP_TRLINE			5
#define COMP_OPENSTUB		6
#define COMP_SHUNTSTUB		7
*/
CMatchingElem* CreateElement(LPCTSTR name, CMatchingElem* chain)
{
	CMatchingElem* res = NULL;
	tstring tstr(name);

	if ( _tcscmp(_T("cascade L"), name)==0 )
		res = new CCascadedInd(chain);
	else if ( _tcscmp(_T("cascade C"), name)==0 )
		res = new CCascadedCap(chain);
	else if ( _tcscmp(_T("shunt C"), name)==0 )
		res = new CShuntedCap(chain);
	else if ( _tcscmp(_T("shunt L"), name)==0 )
		res = new CShuntedInd(chain);
	else if ( _tcscmp(_T("trans line"), name)==0 )
		res = new CTransmissionLine(chain);
	else if ( _tcscmp(_T("shunt stub"), name)==0 )
		res = new CShuntStub(chain);
	else if ( _tcscmp(_T("open stub"), name)==0 )
		res = new COpenStub(chain);

	return res;
}

