#include "stdafx.h"
#include "SmithChart.h"
#include "MatchingElem.h"
#include "MelonSweep.h"
#include "MelonDesign.h"

// fUCX~X`[gɕ`悵܂
void CMelonDesign::Draw(CSmithChart& chart)
{
	// dˌWvbg܂
	sweep_const_iterator si;
	for ( si=mSweeps.begin(); si!=mSweeps.end(); si++ ) {
		(*si)->Draw(chart, mElements.back());
		(*si)->DrawNote(chart);
	}
}
//---------------------------------------------------------------------------

// }[J[`悵܂
void CMelonDesign::DrawMarker(CSmithChart& chart)
{
	// }[J[̖}ɏo͂܂
	marker_const_iterator mi;
	for ( mi=mMarkers.begin(); mi!=mMarkers.end(); mi++ ) {
		(*mi)->Draw(chart, mElements.back());
		(*mi)->DrawNote(chart, mElements.back());
	}
}
//---------------------------------------------------------------------------

// vfړ܂
void CMelonDesign::MoveElement(size_type dest, size_type src)
{
	elem_iterator mid;

	if ( dest>=mElements.size() || src>=mElements.size() ) return;

	// vfړ̑OɈړ܂
	if ( src>dest ) {
		mid = mElements.begin() + src;
		std::rotate(mElements.begin()+dest, mid, mElements.begin()+src+1);
		update_chain();
		Update(dest);
	}

	// vfړ̌Ɉړ܂
	else {
		mid = mElements.begin() + src + 1;
		std::rotate(mElements.begin()+src, mid, mElements.begin()+dest+1);
		update_chain();
		Update(src);
	}
}
//---------------------------------------------------------------------------

// vf폜܂
void CMelonDesign::DelElement(size_type index)
{
	if ( index<mElements.size() ) {

		delete mElements[index];
		mElements.erase(mElements.begin() + index);
		update_chain();
		Update(index);
	}
}
//---------------------------------------------------------------------------

// vf}܂
void CMelonDesign::InsertElement(size_type dest, CMatchingElem* elem)
{
	elem_iterator it = mElements.begin();

	// vfẅʒuɒǉ܂
	if ( dest<mElements.size() ) {
		mElements.insert(it + dest, elem);
		update_chain();
		Update(dest);
	}

	// vfŌɒǉ܂
	else {
		mElements.push_back(elem);
		update_chain();
		Update(mElements.size() - 1);
	}
}
//---------------------------------------------------------------------------

// vfu܂
void CMelonDesign::SwapElement(size_type dest, CMatchingElem* elem)
{
	// vfu܂
	if ( dest>0 && dest<mElements.size() ) {

		std::swap(mElements[dest], elem);
		delete elem;
		update_chain();
		Update(dest);
	}
	else throw _T("invalid parameter.");
}
//---------------------------------------------------------------------------

// vfǉ܂
void CMelonDesign::AddElement(CMatchingElem* elem)
{
	mElements.push_back(elem);
	update_chain();
	Update(mElements.size() - 1);
}
//---------------------------------------------------------------------------

// g|ǉ܂
void CMelonDesign::AddSweep(double start, double stop)
{
	tstringstream tstrm;
	mSweeps.push_back(new CMelonSweep(start, stop));
	tstrm << _T("sweep") << mSweeps.size();
	mSweeps.back()->SetSweepName(tstrm.str().c_str());
}
//---------------------------------------------------------------------------

// ftHgg|ǉ܂
void CMelonDesign::AddSweep()
{
	SolutionPtr sol = mElements.front()->GetSolution();
	AddSweep(sol->front(), sol->back());
}
//---------------------------------------------------------------------------

// g|폜܂
void CMelonDesign::DelSweep(size_type index)
{
	if ( index<mSweeps.size() ) {
		delete mSweeps[index];
		mSweeps.erase(mSweeps.begin() + index);
	}
}
//---------------------------------------------------------------------------

// }[J[ǉ܂
void CMelonDesign::AddMarker(double freq)
{
	mMarkers.push_back(new CMelonMarker(_T("marker"), freq));
}
//---------------------------------------------------------------------------

// }[J[폜܂
void CMelonDesign::DelMarker(size_type index)
{
	if ( index<mMarkers.size() ) {
		delete mMarkers[index];
		mMarkers.erase(mMarkers.begin() + index);
	}
}
//---------------------------------------------------------------------------

// XgXV܂
void CMelonDesign::Update(size_type index)
{
	elem_iterator it;

	for ( it=mElements.begin() + index; it!=mElements.end(); it++ )
		(*it)->Update();
}
//---------------------------------------------------------------------------

// `F[XV܂
void CMelonDesign::update_chain()
{
	size_type i;

	for ( i=0; i<mElements.size()-1; i++ )
		mElements[i+1]->SetChain( mElements[i] );
}
//---------------------------------------------------------------------------

// RXgN^
CMelonDesign::CMelonDesign(CMatchingElem* term)
{
	using namespace std;

	mElements.push_back(term);
	SolutionPtr sol = term->GetSolution();

	// őlƍŏl擾āAg͈͂ݒ肵܂
	if ( sol->size()>0 ) {
		mSweeps.push_back( new CMelonSweep( sol->front(), sol->back() ) );
		mSweeps.back()->SetSweepName(_T("sweep1"));
	}

	// Xe[^X̏
	mStatus = DESIGN_VISIBLE;
	mDesignName = _T("new design");
}
//---------------------------------------------------------------------------

// fXgN^
CMelonDesign::~CMelonDesign()
{
	// HIuWFNgj
	elem_iterator ei;
	for ( ei=mElements.begin(); ei!=mElements.end(); ei++ ) delete (*ei);
	
	// g|IuWFNgj
	sweep_const_iterator si;
	for ( si=mSweeps.begin(); si!=mSweeps.end(); si++ ) delete (*si);

	// }[J[j
	marker_const_iterator mi;
	for ( mi=mMarkers.begin(); mi!=mMarkers.end(); mi++ ) delete (*mi);
}
//---------------------------------------------------------------------------
