#pragma once
#include "stdafx.h"

//---------------------------------------------------------------------------
//
//	melon fUCf[^
//
//---------------------------------------------------------------------------
const DWORD DESIGN_VISIBLE	= 1<<0;
const DWORD DESIGN_ACTIVE	= 1<<1;

class CMatchingElem;
class CMelonSweep;
class CMelonMarker;
class CSmithChart;
class CMelonDesign
{
public:
	typedef unsigned int size_type;

	typedef std::vector<CMatchingElem*> elem_array;
	typedef elem_array::iterator elem_iterator;
	typedef elem_array::const_iterator elem_const_iterator;

	typedef std::vector<CMelonSweep*> sweep_array;
	typedef sweep_array::iterator sweep_iterator;
	typedef sweep_array::const_iterator sweep_const_iterator;

	typedef std::vector<CMelonMarker*> marker_array;
	typedef marker_array::iterator marker_iterator;
	typedef marker_array::const_iterator marker_const_iterator;

private:
	
	DWORD	mStatus;
	WTL::CString	mDesignName;

	std::vector<CMatchingElem*>		mElements;
	std::vector<CMelonSweep*>		mSweeps;
	std::vector<CMelonMarker*>		mMarkers;

	void update_chain();

public:
	// RXgN^ƃfXgN^
	CMelonDesign(CMatchingElem* term);
	virtual ~CMelonDesign();
	
	
	// fUCvbg܂
	void Draw(CSmithChart& chart);
	void DrawMarker(CSmithChart& chart);

	// f[^̑
	void Update(size_type index=0);
	
	// Xg̑
	void MoveElement(size_type dest, size_type src);
	void InsertElement(size_type dest, CMatchingElem* elem);
	void SwapElement(size_type dest, CMatchingElem* elem);
	void DelElement(size_type index);
	void AddElement(CMatchingElem* elem);

	void DelSweep(size_type index);
	void AddSweep();
	void AddSweep(double start, double stop);

	void DelMarker(size_type index);
	void AddMarker(double freq);


	// HCe[^̎擾
	elem_iterator FirstElem()	{ return mElements.begin(); }
	elem_iterator LastElem()	{ return mElements.end(); }
	elem_const_iterator FirstElem() const	{ return mElements.begin(); }
	elem_const_iterator LastElem() const	{ return mElements.end(); }
	size_type ElemCount() const { return mElements.size(); }
	CMatchingElem* Elem(size_type index) {
		return (mElements.size()<=index) ? NULL : mElements[index];
	}

	// g|IuWFNg̃Ce[^
	sweep_iterator FirstSweep()	{ return mSweeps.begin(); }
	sweep_iterator LastSweep()	{ return mSweeps.end(); }
	sweep_const_iterator FirstSweep() const	{ return mSweeps.begin(); }
	sweep_const_iterator LastSweep() const	{ return mSweeps.end(); }
	size_type SweepCount() const{ return mSweeps.size(); }
	CMelonSweep* Sweep(size_type index) {
		return (mSweeps.size()<=index) ? NULL : mSweeps[index];
	}

	// }[J[IuWFNg̃Ce[^
	marker_iterator FirstMarker()	{ return mMarkers.begin(); }
	marker_iterator LastMarker()	{ return mMarkers.end(); }
	marker_const_iterator FirstMarker() const	{ return mMarkers.begin(); }
	marker_const_iterator LastMarker() const	{ return mMarkers.end(); }
	size_type MarkerCount() const { return mMarkers.size(); }
	CMelonMarker* Marker(size_type index) {
		return (mMarkers.size()<=index) ? NULL : mMarkers[index];
	}


	// fUCl[
	void SetDesignName(LPCTSTR name)	{ mDesignName = name; }
	LPCTSTR GetDesignName() const		{ return mDesignName; }

	// Xe[^X̐ݒ
	void SetStatus(DWORD stat) { mStatus |= stat; }
	void ClrStatus(DWORD stat) { mStatus &= ~stat; }
	bool IsStatus(DWORD mask) const { return mStatus & mask; }
	DWORD GetStatus() const { return mStatus; }
};
