#pragma once
#include "MelonDesign.h"

//---------------------------------------------------------------------------
//
//	hLgNX
//
//---------------------------------------------------------------------------
class CSmithChart;
class CMelonDocument
{
public:
	typedef std::vector<CMelonDesign*> design_array;
	typedef design_array::iterator design_iterator;
	typedef design_array::const_iterator design_const_iterator;
	typedef design_array::size_type size_type;

private:
	// fUCXg
	int		mActiveIndex;
	design_array	mDesignList;
	CMelonDesign*	mActiveDesign;

public:
	// RXgN^AfXgN^
	CMelonDocument();
	virtual ~CMelonDocument();

	// hLgvbg܂
	void Draw(CSmithChart& chart);
	void ActivateDesign(size_type index);
	int GetActiveIndex() const { return mActiveIndex; }
	CMelonDesign* GetActiveDesign() { return mActiveDesign; }


	// fUC̎Q
	CMelonDesign* operator[](size_type index)
		{ return mDesignList[index]; }
	const CMelonDesign* operator[](size_type index) const
		{ return mDesignList[index]; }

	// fUC̎Q
	size_type size() const { return mDesignList.size(); }

	// fUC̒ǉ
	void AddDesign(CMelonDesign* design);
	void AddDesign(CMatchingElem* term);

	// fUC̍폜
	void DelDesign(size_type index);
	void Clear();
};
