#include "stdafx.h"
#include "MelonDocument.h"
#include "MainForm.h"
#include "SmithChart.h"
#include "MelonManager.h"

//---------------------------------------------------------------------------
//
//	AvP[VǗNX
//
//---------------------------------------------------------------------------

// hLgĕ`悵܂
void CMelonManager::UpdateSmithChart()
{
	mRedraw = true;
}
//---------------------------------------------------------------------------

// X~X`[gĕ`v
void CMelonManager::drawSmithWindow()
{
	if ( mMainFrame.mSmithChart.IsWindow() ) {

		// EChEnhGraphcisIuWFNg쐬܂
		CDIBitmap* bmp = mMainFrame.mSmithChart.GetCanvas();
		Gdiplus::Graphics g( bmp->GetDC(mMainFrame.mSmithChart) );

		// X~X`[g`
		DrawSmithChart(g);

		// DCJāAEChEXV܂
		bmp->ReleaseDC();
		mMainFrame.mSmithChart.Invalidate();
	}
}
//---------------------------------------------------------------------------

// X~X`[gw肳ꂽLoXɕ`悵܂
void CMelonManager::DrawSmithChart(Gdiplus::Graphics &g)
{
	if ( mMainFrame.mSmithChart.IsWindow() ) {

		// EChEnhGraphcisIuWFNg쐬܂
		g.SetSmoothingMode( Gdiplus::SmoothingModeAntiAlias );
		g.SetTransform( mMainFrame.mSmithChart.GetTransform() );

		// X~X`[g쐬E`悵܂
		CSmithChart smith(&g, mSmithStyle);
		smith.Clear();

		if ( pDocument!=NULL )
			pDocument->Draw(smith);
	}
}
//---------------------------------------------------------------------------

// w肳ꂽGUIXV܂
void CMelonManager::UpdateControl(DWORD id)
{
	if ( id & CTRL_SMITHCHART )
		UpdateSmithChart();
	if ( id & CTRL_DESIGNLIST )
		UpdateDesignList();
	if ( id & CTRL_MATCHLIST )
		UpdateMatchList();
	if ( id & CTRL_SWEEPLIST )
		UpdateSweepList();
	if ( id & CTRL_MARKERLIST )
		UpdateMarkerList();
}
//---------------------------------------------------------------------------

// fUCXgXV܂
void CMelonManager::UpdateDesignList()
{
	mMainFrame.mPropForm.SetDocument( pDocument );
}
//---------------------------------------------------------------------------

// }b`OXgXV܂
void CMelonManager::UpdateMatchList()
{
	mMainFrame.mMatchingList.SetDesign( pDocument->GetActiveDesign() );
}
//---------------------------------------------------------------------------

// gXgXV܂
void CMelonManager::UpdateSweepList()
{
	mMainFrame.mSweepList.SetDesign( pDocument->GetActiveDesign() );
}
//---------------------------------------------------------------------------

// f[^}[J[XgXV܂
void CMelonManager::UpdateMarkerList()
{
	mMainFrame.mMarkerList.SetDesign( pDocument->GetActiveDesign() );
}
//---------------------------------------------------------------------------

// vpeBXgXV܂
void CMelonManager::UpdatePropList(IParamInterface* item)
{
	mMainFrame.mPropForm.mPropertyList.SetProperties(item);
}
//---------------------------------------------------------------------------

// fUCݒ肵܂
void CMelonManager::SetDocument(CMelonDocument* doc)
{
	if ( pDocument!=NULL ) delete pDocument;
	pDocument = doc;
}
//---------------------------------------------------------------------------

// fUCQƂ܂
CMelonDesign* CMelonManager::GetDesign(unsigned int index)
{
	return ( index<pDocument->size() ) ? (*pDocument)[index] : NULL;
}
//---------------------------------------------------------------------------

// ANeBuȃfUCQƂ܂
CMelonDesign* CMelonManager::GetDesign()
{
	return pDocument->GetActiveDesign();
}
//---------------------------------------------------------------------------

// AChCxg
void CMelonManager::OnIdle()
{
	drawSmithWindow();
	mRedraw = false;
}
//---------------------------------------------------------------------------

// RXgN^
CMelonManager::CMelonManager(CMainFrame& frm)
	: mMainFrame(frm), pDocument(NULL), mRedraw(true)
{
	pDocument = new CMelonDocument();
	mSmithStyle = new CBasicSmithStyle();
}
//---------------------------------------------------------------------------

// fXgN^
CMelonManager::~CMelonManager()
{
	if ( pDocument!=NULL ) delete pDocument;
	delete mSmithStyle;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	ǗNXANZX
//
//---------------------------------------------------------------------------

// CX^X
CMelonManager* CManagerAccess::pManager;

// CX^Xݒ
void CManagerAccess::SetManager(CMelonManager *mgr)
{
	// ݒ1񂾂
	if ( pManager==NULL ) pManager = mgr;
}
//---------------------------------------------------------------------------
