#include "stdafx.h"
#include "ListItem.h"
#include "SmithChart.h"
#include "MatchingElem.h"
#include "MelonUnits.h"
#include "MyListView.h"
#include "MelonSweep.h"
#include <boost/algorithm/string.hpp>

//---------------------------------------------------------------------------
//
//	melon g|͈̓NX
//
//---------------------------------------------------------------------------

// `惁\bh
void CMelonSweep::Draw(CSmithChart& chart, CMatchingElem* src)
{
	using namespace std;

	// ͈͎wŃvbg܂
	complex_array::const_iterator beg, end;
	beg = src->lower_bound(mStart - numeric_limits<double>::epsilon());
	end = src->upper_bound(mStop);
	if ( beg<end )
		chart.Plot(mPen, beg, end);
}
//---------------------------------------------------------------------------

// `惁\bh
void CMelonSweep::DrawNote(CSmithChart& chart)
{
	if ( mShowNote ) {
		chart.WriteLine(mPen, mSweepName);
		chart.VSpace(0.5f);
	}
}
//---------------------------------------------------------------------------

// p[^ݒ肵܂
void CMelonSweep::SetParam(IListItem& item)
{
	tstringstream tstrm;
	tstring stop_unit, start_unit;
	CMelonUnits item_unit;
	double start, stop;

	// OXV܂
	mSweepName = item.GetText(0);

	try {
		// őg擾܂
		tstrm.str( item.GetText(2) );
		tstrm >> mStop;
		if ( tstrm.fail() ) throw _T("invalid parameter.");
		tstrm >> stop_unit;

		// ŏg擾܂
		tstrm.clear();
		tstrm.str( item.GetText(1) );
		tstrm >> mStart;
		if ( tstrm.fail() ) throw _T("invalid parameter.");
		tstrm >> start_unit;

		using namespace boost;
		algorithm::trim_left(stop_unit);
		trim_left(start_unit);

		// őgɒPʎw肪ꍇ
		if ( !stop_unit.empty() ) {
			mUnit.SetUnit( stop_unit.c_str() );
			mStop *= mUnit.GetUnit();
			item_unit.SetUnit( item.GetText(3) );
			mStart *= item_unit.GetUnit();
		}

		// ŏgɒPʎw肪ꍇ
		else if ( !start_unit.empty() ) {
			mUnit.SetUnit( start_unit.c_str() );
			mStart *= mUnit.GetUnit();
			item_unit.SetUnit( item.GetText(3) );
			mStop *= item_unit.GetUnit();
		}

		// Pʎw肪Ȃꍇ
		else {
			mUnit.SetUnit( item.GetText(3) );
			mStart *= mUnit.GetUnit();
			mStop *= mUnit.GetUnit();
		}
	}
	catch (LPCTSTR e)
	{
	}

	// \XV܂
	GetParam(item);
}
//---------------------------------------------------------------------------

// p[^擾܂
void CMelonSweep::GetParam(IListItem& item)
{
	// ڂƃACR̐ݒ
	item.SetImage(-1);
	item.SetText(0, mSweepName);
	item.SetEditType(0, EDIT_TEXTBOX);
	item.SetEditType(1, EDIT_TEXTBOX);
	item.SetEditType(2, EDIT_TEXTBOX);
	item.SetEditType(3, EDIT_TEXTBOX);

	// p[^̐ݒ
	tstringstream tstr;
	tstr << mUnit(mStart);
	item.SetText(1, tstr.str().c_str());
	
	tstr.str(_T(""));
	tstr << mUnit(mStop);
	item.SetText(2, tstr.str().c_str());

	tstr.str(_T(""));
	tstr << mUnit.GetInitial() << _T("Hz");
	item.SetText(3, tstr.str().c_str());
}
//---------------------------------------------------------------------------

// vpeBݒ肵܂
void CMelonSweep::SetProperty(int index, IListItem& item)
{
	double lw;
	Gdiplus::Color cl;

	// w肳ꂽp[^XV܂
	switch ( index ) {
		
		// Jng̐ݒ
		case 0:
			GetVariable(item, mStart, mUnit);
			break;

		// Ig̐ݒ
		case 1:
			GetVariable(item, mStop, mUnit);
			break;

		// ̐ݒ
		case 2:
			if ( GetVariable(item, lw) )
				mPen->SetWidth(lw);
			break;

		// F̐ݒ
		case 3:
			if ( GetVariable(item, cl) )
				mPen->SetColor(cl);
			break;

		// }̗L
		case 4:
			GetVariable(item, mShowNote);
			break;
	}

	// \XV
	GetProperty(index, item);
}
//---------------------------------------------------------------------------

// vpeB擾܂
void CMelonSweep::GetProperty(int index, IListItem& item)
{
	Gdiplus::Color color;

	// w肳ꂽp[^ݒ肵܂
	switch ( index ) {

		// Jng\
		case 0:
			item.SetText(0, _T("start"));
			SetItem(item, mStart, mUnit, _T("Hz"));
			break;

		// Ig\
		case 1:
			item.SetText(0, _T("stop"));
			SetItem(item, mStop, mUnit, _T("Hz"));
			break;

		// \
		case 2:
			item.SetText(0, _T("line width"));
			SetItem(item, mPen->GetWidth());
			break;

		// F\
		case 3:
			item.SetText(0, _T("line color"));
			mPen->GetColor(&color);
			SetItem(item, color);
			break;

		// }̗L\
		case 4:
			item.SetText(0, _T("note"));
			SetItem(item, mShowNote);
			break;
	}
}
//---------------------------------------------------------------------------

// RXgN^
CMelonSweep::CMelonSweep(double start, double stop)
	: mStart(start), mStop(stop), mSweepName(_T("sweep")), mShowNote(true)
{
	mPen = new Gdiplus::Pen(Gdiplus::Color::Red, 1.5f);
	mUnit.AutoUnit(stop);
}
//---------------------------------------------------------------------------

// fXgN^
CMelonSweep::~CMelonSweep()
{
	delete mPen;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	melon f[^}[J[NX
//
//---------------------------------------------------------------------------

// `惁\bh
void CMelonMarker::Draw(CSmithChart& chart, CMatchingElem* src)
{
	using namespace std;

	// }[J[`悵܂
	complex_array::const_iterator it = src->find(mFreq);
	if ( it==src->end() )
		it = src->upper_bound(mFreq);

	if ( it!=src->end() )
		chart.Mark(mPen, mRadius, *it, mName);
}
//---------------------------------------------------------------------------

// }`悵܂
void CMelonMarker::DrawNote(CSmithChart& chart, CMatchingElem* src)
{
	using namespace std;

	// }[J[ʒu̓dˌW擾
	complex_array::const_iterator it = src->find(mFreq);
	if ( it==src->end() )
		it = src->upper_bound(mFreq);

	// }[J[LȂAdˌW}ɏo
	if ( it!=src->end() ) {
		
		tstringstream re, im;
		complex<double> ident(1.0), temp;

		switch ( mDesc ) {
			// 傫ƕΊpɂ\L
			case MARKER_MAGPHASE:
				re << _T("M=") << abs(*it);
				im << _T("A=") << 180.0 * arg(*it) / M_PI;
				break;

			// Cs[_X\L
			case MARKER_IMPEDANCE:
				temp = (ident + *it) / (ident - *it);
				re << _T("R=") << temp.real();
				im << _T("X=") << temp.imag();
				break;

			// Ah~^X\L
			case MARKER_ADMITTANCE:
				temp = (ident - *it) / (ident + *it);
				re << _T("G=") << temp.real();
				im << _T("B=") << temp.imag();
				break;
		}
		
		// }[J[\܂
		if ( mDesc!=MARKER_NONE ) {
			chart.WriteLine(mName);
			chart.WriteLine(&re.str()[0]);
			chart.WriteLine(&im.str()[0]);
			chart.VSpace(0.5f);
		}
	}
}
//---------------------------------------------------------------------------

// p[^ݒ肵܂
void CMelonMarker::SetParam(IListItem& item)
{
	tstringstream tstrm;
	tstring unit_text;
	CMelonUnits item_unit;

	// OXV܂
	mName = item.GetText(0);

	try {
		// g擾܂
		tstrm.str( item.GetText(1) );
		tstrm >> mFreq;
		if ( tstrm.fail() ) throw _T("invalid parameter.");
		tstrm >> unit_text;

		using namespace boost;
		algorithm::trim_left(unit_text);

		// Pʎw肪ꍇ
		if ( !unit_text.empty() ) {
			mUnit.SetUnit( unit_text.c_str() );
			mFreq *= mUnit.GetUnit();
		}

		// Pʎw肪Ȃꍇ
		else {
			mUnit.SetUnit( item.GetText(2) );
			mFreq *= mUnit.GetUnit();
		}
	}
	catch (LPCTSTR e)
	{
	}

	// \XV܂
	GetParam(item);
}
//---------------------------------------------------------------------------

// p[^擾܂
void CMelonMarker::GetParam(IListItem& item)
{
	// ڂƃACR̐ݒ
	item.SetImage(-1);
	item.SetText(0, mName);
	item.SetEditType(0, EDIT_TEXTBOX);
	item.SetEditType(1, EDIT_TEXTBOX);
	item.SetEditType(2, EDIT_TEXTBOX);

	// p[^̐ݒ
	tstringstream tstr;
	tstr << mUnit(mFreq);
	item.SetText(1, tstr.str().c_str());
	
	tstr.str(_T(""));
	tstr << mUnit.GetInitial() << _T("Hz");
	item.SetText(2, tstr.str().c_str());
}
//---------------------------------------------------------------------------

// vpeBݒ肵܂
void CMelonMarker::SetProperty(int index, IListItem& item)
{
	double d;
	Gdiplus::Color cl;

	// w肳ꂽp[^XV܂
	switch ( index ) {

		// }[J[gݒ肵܂
		case 0:
			GetVariable(item, mFreq, mUnit);
			break;

		// }[J[̔aݒ
		case 1:
			GetVariable(item, mRadius);
			break;

		// ̐ݒ
		case 2:
			if ( GetVariable(item, d) )
				mPen->SetWidth(d);
			break;

		// F̐ݒ
		case 3:
			if ( GetVariable(item, cl) )
				mPen->SetColor(cl);
			break;

		// \L@̐ݒ
		case 4:
			Item2Desc(item, mDesc);
			break;
	}

	// \XV
	GetProperty(index, item);
}
//---------------------------------------------------------------------------

// vpeB擾܂
void CMelonMarker::GetProperty(int index, IListItem& item)
{
	Gdiplus::Color cl;

	// w肳ꂽp[^ݒ肵܂
	switch ( index ) {

		// }[J[g\
		case 0:
			item.SetText(0, _T("freq"));
			SetItem(item, mFreq, mUnit, _T("Hz"));
			break;

		// }[J[a\
		case 1:
			item.SetText(0, _T("radius"));
			SetItem(item, mRadius);
			break;

		// \
		case 2:
			item.SetText(0, _T("line width"));
			SetItem(item, mPen->GetWidth());
			break;

		// F\
		case 3:
			item.SetText(0, _T("line color"));
			mPen->GetColor(&cl);
			SetItem(item, cl);
			break;

		// \L@\
		case 4:
			Desc2Item(item, mDesc);
			break;
	}
}
//---------------------------------------------------------------------------

// \L@ݒ肵܂
void CMelonMarker::Item2Desc(IListItem& item, int& desc)
{
	if ( !_tcscmp(item.GetText(1), _T("Mag Phase")) ) {
		desc = MARKER_MAGPHASE;
	}
	else if ( !_tcscmp(item.GetText(1), _T("Impedance")) ) {
		desc = MARKER_IMPEDANCE;
	}
	else if ( !_tcscmp(item.GetText(1), _T("Admittance")) ) {
		desc = MARKER_ADMITTANCE;
	}
	else {
		desc = MARKER_NONE;
	}
}
//---------------------------------------------------------------------------

// \L@Xgɕ\܂
void CMelonMarker::Desc2Item(IListItem& item, int desc)
{
	switch ( desc ) {
		case MARKER_MAGPHASE:
			item.SetText(1, _T("Mag Phase"));
			break;

		case MARKER_IMPEDANCE:
			item.SetText(1, _T("Impedance"));
			break;

		case MARKER_ADMITTANCE:
			item.SetText(1, _T("Admittance"));
			break;

		default:
			item.SetText(1, _T("None"));
			break;
	}
	
	item.SetText(0, _T("Style"));
	item.SetEditType(0, EDIT_DISABLED);
	item.SetEditType(1, EDIT_DESCLIST);
}
//---------------------------------------------------------------------------

// ftHgRXgN^
CMelonMarker::CMelonMarker()
{
	mName = _T("mark");
	mFreq = 0.0;
	mRadius = 2.0f;
	mDesc = MARKER_MAGPHASE;
	mPen = new Gdiplus::Pen(Gdiplus::Color::Black, 1.5f);
}
//---------------------------------------------------------------------------

// RXgN^
CMelonMarker::CMelonMarker(LPCTSTR name, double freq)
	: mName(name), mFreq(freq)
{
	mRadius = 2.0f;
	mDesc = MARKER_MAGPHASE;
	mUnit.AutoUnit(freq);
	mPen = new Gdiplus::Pen(Gdiplus::Color::Black, 1.5f);
}
//---------------------------------------------------------------------------

// fXgN^
CMelonMarker::~CMelonMarker()
{
	delete mPen;
}
//---------------------------------------------------------------------------
