#pragma once
#include "ListItem.h"
#include "ParamInterface.h"
#include "MelonUnits.h"

//---------------------------------------------------------------------------
//
//	melon g|͈̓NX
//
//---------------------------------------------------------------------------
class CSmithChart;
class CMatchingElem;
class CMelonSweep : public IParamInterface
{
private:
	bool	mShowNote;
	double	mStart;
	double	mStop;
	CMelonUnits		mUnit;
	Gdiplus::Pen*	mPen;
	WTL::CString	mSweepName;

public:
	// RXgN^ƃfXgN^
	CMelonSweep(double start=10.0e6, double stop=10.0e9);
	virtual ~CMelonSweep();

	// `惁\bh
	void Draw(CSmithChart& chart, CMatchingElem* src);
	void DrawNote(CSmithChart& chart);

	// ANZX\bh
	double GetStart() const
		{ return mStart; }
	void SetStart(double start)
		{ mStart = start; }

	double GetStop() const
		{ return mStop; }
	void SetStop(double stop)
		{ mStop = stop; }

	Gdiplus::Pen* GetPen()
		{ return mPen; }
	const Gdiplus::Pen* GetPen() const
		{ return mPen; }

	// p[^̓o
	void SetParam(IListItem& item);
	void GetParam(IListItem& item);
	
	// vpeB̓o
	void SetProperty(int index, IListItem& item);
	void GetProperty(int index, IListItem& item);
	int NumProperties() const { return 5; }
	
	// fUCl[
	void SetSweepName(LPCTSTR name)	{ mSweepName = name; }
	LPCTSTR GetSweepName() const	{ return mSweepName; }
};

//---------------------------------------------------------------------------
//
//	melon f[^}[J[NX
//
//---------------------------------------------------------------------------
const int MARKER_NONE		= 0;
const int MARKER_MAGPHASE	= 1;
const int MARKER_IMPEDANCE	= 2;
const int MARKER_ADMITTANCE	= 3;
class CMelonMarker : public IParamInterface
{
private:
	double	mFreq;
	float	mRadius;
	int		mDesc;
	CMelonUnits		mUnit;
	WTL::CString	mName;
	Gdiplus::Pen*	mPen;

	// }[J[\L
	void Item2Desc(IListItem& item, int& desc);
	void Desc2Item(IListItem& item, int desc);

public:
	// RXgN^ƃfXgN^
	CMelonMarker();
	CMelonMarker(LPCTSTR name, double mFreq);
	~CMelonMarker();

	// `惁\bh
	void Draw(CSmithChart& chart, CMatchingElem* src);
	void DrawNote(CSmithChart& chart, CMatchingElem* src);

	// ANZX\bh
	double GetFreq() const
		{ return mFreq; }
	void SetFreq(double freq)
		{ mFreq = freq; }

	LPCTSTR GetText() const
		{ return (LPCTSTR)mName; }
	void SetText(LPCTSTR name)
		{ mName = name; }

	Gdiplus::Pen* GetPen()
		{ return mPen; }
	const Gdiplus::Pen* GetPen() const
		{ return mPen; }
	
	// p[^̓o
	void SetParam(IListItem& item);
	void GetParam(IListItem& item);
	
	// vpeB̓o
	void SetProperty(int index, IListItem& item);
	void GetProperty(int index, IListItem& item);
	int NumProperties() const { return 5; }
};
