#include "stdafx.h"
#include "MatchingElem.h"
#include "MelonDocument.h"
#include "MelonSweep.h"
#include "MyListView.h"
#include "ParamInterface.h"

//---------------------------------------------------------------------------
//
//	Hp̃Xgr[
//
//---------------------------------------------------------------------------

// Hp[^ύX܂
void CMatchListView::EndItemEdit(int item, int sub_item)
{
	CMelonDesign* design = GetManager()->GetDesign();
	CMelonDesign::elem_iterator it;

	// fUCNULL`FbN
	if ( design!=NULL ) {

		// p[^ݒAĕ`悵܂
		if ( item>=0 && item<design->ElemCount() ) {

			// H\̕ύX
			if ( sub_item!=0 ) {
				it = design->FirstElem() + item;
				(*it)->SetParam((*this)[item]);
				design->Update(item);
			}

			// H\ύX
			else if ( item>0 ) {

				CMatchingElem* match = CreateElement( (*this)[item].GetText(0), NULL );
				if ( match!=NULL ) {
					
					design->SwapElement(item, match);
					match->GetParam((*this)[item]);
				}
			}

			// fUCƃX~X`[gXV܂
			GetManager()->UpdateSmithChart();
		}

		// uNҏWŁAgW̒ǉ
		else if ( item==design->ElemCount() ) {

			CMatchingElem* match = CreateElement(
				(*this)[item].GetText(0), NULL);
			
			if ( match!=NULL ) {

				// gǉ
				design->AddElement(match);
				it = design->FirstElem() + item;

				// XgƃX~X`[gXV
				(*it)->SetParam((*this)[item]);
				AddListItem(mBlankItem);
				GetManager()->UpdateSmithChart();
			}
		}
	}
}
//---------------------------------------------------------------------------

// ACeICxg
LRESULT CMatchListView::OnItemChanged(LPNMHDR pnmh)
{
	LPNMLISTVIEW item = reinterpret_cast<LPNMLISTVIEW>(pnmh);
	CMelonDesign* design = GetManager()->GetDesign();

	// fUCNULL`FbN
	if ( design!=NULL ) {

		// ACeXe[gŃtB^
		if ( item->uOldState==0 )
			GetManager()->UpdatePropList(design->Elem(item->iItem));
	}

	return FALSE;
}
//---------------------------------------------------------------------------

// ACeNbNCxg
void CMatchListView::OnLButtonDown(UINT nFlags, CPoint point)
{
	int index = HitTest(point, &nFlags);
	CMelonDesign* design = GetManager()->GetDesign();

	// fUCNULL`FbN
	if ( design!=NULL ) {

		// I𒆂̃ACexNbNꍇ
		if ( index>=0 && index==GetSelectedIndex() )
			GetManager()->UpdatePropList(design->Elem(index));
	}

	SetMsgHandled(false);
}
//---------------------------------------------------------------------------

// L[_ECxg
void CMatchListView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// fUCNULL`FbN
	CMelonDesign* design = GetManager()->GetDesign();
	if ( design!=NULL ) {

		// }[J[폜܂
		if ( nChar==VK_DELETE && GetSelectedIndex()!=0 ) {
			design->DelElement( GetSelectedIndex() );
			GetManager()->UpdateControl(CTRL_MATCHLIST |CTRL_SMITHCHART);
			GetManager()->UpdatePropList(NULL);
		}
	}
	SetMsgHandled(false);
}
//---------------------------------------------------------------------------

// fUCݒ肵܂
void CMatchListView::SetDesign(CMelonDesign* design)
{
	// fUC`FbN
	if ( design!=NULL ) {

		unsigned int n = 0;
		CMelonDesign::elem_iterator it;
		
		// ڐĐݒ肵܂
		SetItemCount( design->ElemCount() );

		// HԂɃXgɐݒ肵Ă܂
		for ( it=design->FirstElem(); it!=design->LastElem(); it++, n++ ) {
			(*it)->GetParam( (*this)[ n ] );
		}
		
		// uNACeŌɒǉ
		AddListItem(mBlankItem);
	}
	
	// fUCꍇ́AXgNA܂
	else
		ClearListItem();

	// ĕ`
	Invalidate();
}
//---------------------------------------------------------------------------

// hbOhbv̏
void CMatchListView::EndItemDrop(int dest, int item)
{
	CMelonDesign* design = GetManager()->GetDesign();

	// fUC`FbN
	if ( design!=NULL ) {

		//LȃhbvCfbNX̏ꍇ̏
		if ( dest<design->ElemCount() && dest>0 && dest!=item ) {
		
			// Hבւ܂
			design->MoveElement(dest, item);

			// ACeבւ܂
			CMatchListView::iterator mid;
			if ( item>dest ) {
				mid = begin() + item;
				std::rotate(begin()+dest, mid, begin()+item+1);
				RedrawItems(dest, item);
			}
			else {
				mid = begin() + item + 1;
				std::rotate(begin()+item, mid, begin()+dest+1);
				RedrawItems(item, dest);
			}
		}
	}
}
//---------------------------------------------------------------------------

// RXgN^
CMatchListView::CMatchListView()
{
	// uNACe쐬
	mBlankItem.SetImage(-1);
	mBlankItem.SetText(0, _T(""));
	mBlankItem.SetEditType(0, EDIT_COMPLIST);
	mBlankItem.SetText(1, _T(""));
	mBlankItem.SetEditType(1, EDIT_DISABLED);
	mBlankItem.SetText(2, _T(""));
	mBlankItem.SetEditType(2, EDIT_DISABLED);
	mBlankItem.SetText(3, _T(""));
	mBlankItem.SetEditType(3, EDIT_DISABLED);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	gW̃Xgr[
//
//---------------------------------------------------------------------------

// ACeICxg
LRESULT CSweepListView::OnItemChanged(LPNMHDR pnmh)
{
	LPNMLISTVIEW item = reinterpret_cast<LPNMLISTVIEW>(pnmh);
	CMelonDesign* design = GetManager()->GetDesign();

	// fUCNULL`FbN
	if ( design!=NULL ) {

		// ACeXe[gŃtB^
		if ( item->uOldState==0 )
			GetManager()->UpdatePropList(design->Sweep(item->iItem));
	}

	return FALSE;
}
//---------------------------------------------------------------------------

// ACeNbNCxg
void CSweepListView::OnLButtonDown(UINT nFlags, CPoint point)
{
	int index = HitTest(point, &nFlags);
	CMelonDesign* design = GetManager()->GetDesign();

	// fUCNULL`FbN
	if ( design!=NULL ) {

		// I𒆂̃ACexNbNꍇ
		if ( index>=0 && index==GetSelectedIndex() )
			GetManager()->UpdatePropList(design->Sweep(index));
	}

	SetMsgHandled(false);
}
//---------------------------------------------------------------------------

// gWύX܂
void CSweepListView::EndItemEdit(int item, int sub_item)
{
	CMelonDesign* design = GetManager()->GetDesign();
	CMelonDesign::sweep_iterator it;

	// fUC̃`FbN
	if ( design!=NULL ) {

		// p[^ݒAĕ`悵܂
		if ( item>=0 && item<design->SweepCount() ) {

			it = design->FirstSweep() + item;
			(*it)->SetParam((*this)[ (unsigned int)item ]);
			GetManager()->UpdateSmithChart();
		}

		// uNҏWŁAgW̒ǉ
		else if ( item==design->SweepCount() ) {

			// gǉ
			design->AddSweep();
			it = design->FirstSweep() + item;

			// XgƃX~X`[gXV
			(*it)->SetParam((*this)[ (unsigned int)item ]);
			AddListItem(mBlankItem);
			GetManager()->UpdateSmithChart();
		}
	}
}
//---------------------------------------------------------------------------

// fUCgW̃Xg쐬
void CSweepListView::SetDesign(CMelonDesign* design)
{
	// fUC`FbN
	if ( design!=NULL ) {

		unsigned int n = 0;
		CMelonDesign::sweep_iterator it;
		
		// ڐĐݒ肵܂
		SetItemCount( design->SweepCount() );

		// HԂɃXgɐݒ肵Ă܂
		for ( it=design->FirstSweep(); it!=design->LastSweep(); it++, n++ ) {
			(*it)->GetParam( (*this)[ n ] );
		}
		
		// uNACeŌɒǉ
		AddListItem(mBlankItem);
	}
	
	// fUCꍇ́AXgNA܂
	else
		ClearListItem();

	// ĕ`
	Invalidate();
}
//---------------------------------------------------------------------------

// L[_ECxg
void CSweepListView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// fUCNULL`FbN
	CMelonDesign* design = GetManager()->GetDesign();
	if ( design!=NULL ) {

		// }[J[폜܂
		if ( nChar==VK_DELETE ) {
			design->DelSweep( GetSelectedIndex() );
			GetManager()->UpdateControl(CTRL_SWEEPLIST |CTRL_SMITHCHART);
			GetManager()->UpdatePropList(NULL);
		}
	}
	SetMsgHandled(false);
}
//---------------------------------------------------------------------------

// RXgN^
CSweepListView::CSweepListView()
{
	// uNACe쐬
	mBlankItem.SetImage(-1);
	mBlankItem.SetText(0, _T(""));
	mBlankItem.SetEditType(0, EDIT_TEXTBOX);
	mBlankItem.SetText(1, _T(""));
	mBlankItem.SetEditType(1, EDIT_DISABLED);
	mBlankItem.SetText(2, _T(""));
	mBlankItem.SetEditType(2, EDIT_DISABLED);
	mBlankItem.SetText(3, _T(""));
	mBlankItem.SetEditType(3, EDIT_DISABLED);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	f[^}[J[Xgr[
//
//---------------------------------------------------------------------------

// ACeICxg
LRESULT CMarkerListView::OnItemChanged(LPNMHDR pnmh)
{
	LPNMLISTVIEW item = reinterpret_cast<LPNMLISTVIEW>(pnmh);
	CMelonDesign* design = GetManager()->GetDesign();

	// fUCNULL`FbN
	if ( design!=NULL ) {
	
		// ACeXe[gŃtB^
		if ( item->uOldState==0 )
			GetManager()->UpdatePropList(design->Marker(item->iItem));
	}

	return FALSE;
}
//---------------------------------------------------------------------------

// ACeNbNCxg
void CMarkerListView::OnLButtonDown(UINT nFlags, CPoint point)
{
	int index = HitTest(point, &nFlags);
	CMelonDesign* design = GetManager()->GetDesign();

	// fUCNULL`FbN
	if ( design!=NULL ) {

		// I𒆂̃ACexNbNꍇ
		if ( index>=0 && index==GetSelectedIndex() )
			GetManager()->UpdatePropList(design->Marker(index));
	}

	SetMsgHandled(false);
}
//---------------------------------------------------------------------------

// }[J[gύX܂
void CMarkerListView::EndItemEdit(int item, int sub_item)
{
	CMelonDesign* design = GetManager()->GetDesign();
	CMelonDesign::marker_iterator it;

	// fUCNULL`FbN
	if ( design!=NULL ) {

		// p[^ݒAĕ`悵܂
		if ( item>=0 && item<design->MarkerCount() ) {

			it = design->FirstMarker() + item;
			(*it)->SetParam((*this)[ (unsigned int)item ]);
			GetManager()->UpdateSmithChart();
		}

		// uNҏWŁAgW̒ǉ
		else if ( item==design->MarkerCount() ) {

			// gǉ
			design->AddMarker(0.0);
			it = design->FirstMarker() + item;

			// XgƃX~X`[gXV
			(*it)->SetParam((*this)[ (unsigned int)item ]);
			AddListItem(mBlankItem);
			GetManager()->UpdateSmithChart();
		}
	}
}
//---------------------------------------------------------------------------

// fUCgW̃Xg쐬
void CMarkerListView::SetDesign(CMelonDesign* design)
{
	// fUC`FbN
	if ( design!=NULL ) {

		unsigned int n = 0;
		CMelonDesign::marker_iterator it;
		
		// ڐĐݒ肵܂
		SetItemCount( design->MarkerCount() );

		// HԂɃXgɐݒ肵Ă܂
		for ( it=design->FirstMarker(); it!=design->LastMarker(); it++, n++ ) {
			(*it)->GetParam( (*this)[ n ] );
		}
		
		// uNACeŌɒǉ
		AddListItem(mBlankItem);
	}
	
	// fUCꍇ́AXgNA܂
	else
		ClearListItem();

	// ĕ`
	Invalidate();
}
//---------------------------------------------------------------------------

// L[_ECxg
void CMarkerListView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// fUCNULL`FbN
	CMelonDesign* design = GetManager()->GetDesign();
	if ( design!=NULL ) {

		// }[J[폜܂
		if ( nChar==VK_DELETE ) {
			design->DelMarker( GetSelectedIndex() );
			GetManager()->UpdateControl(CTRL_MARKERLIST |CTRL_SMITHCHART);
			GetManager()->UpdatePropList(NULL);
		}
	}
	SetMsgHandled(false);
}
//---------------------------------------------------------------------------

// RXgN^
CMarkerListView::CMarkerListView()
{
	// uNACe쐬
	mBlankItem.SetImage(-1);
	mBlankItem.SetText(0, _T(""));
	mBlankItem.SetEditType(0, EDIT_TEXTBOX);
	mBlankItem.SetText(1, _T(""));
	mBlankItem.SetEditType(1, EDIT_DISABLED);
	mBlankItem.SetText(2, _T(""));
	mBlankItem.SetEditType(2, EDIT_DISABLED);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	vpeBXgr[
//
//---------------------------------------------------------------------------

// vpeBύX
void CPropListView::EndItemEdit(int item, int sub_item)
{
	// Lȃ^[Qbg̏ꍇ
	if ( mItem!=NULL ) {

		// vpeBXV܂
		mItem->SetProperty(item, (*this)[ (unsigned int)item ]);

		// fUCXV܂
		CMelonDesign* design = GetManager()->GetDesign();
		if ( design!=NULL ) design->Update();

		GetManager()->UpdateControl(
			CTRL_SMITHCHART |CTRL_MATCHLIST |CTRL_SWEEPLIST |CTRL_MARKERLIST);
	}
}
//---------------------------------------------------------------------------

// ep[^ƃN
void CPropListView::SetProperties(IParamInterface* item)
{
	int i(0);

	// XgNAāAvpeBݒ肵܂
	ClearListItem();
	mItem = item;
	if ( item!=NULL ) {

		// vpeBԂɎ擾Ă܂
		CBasicListItem3 temp;
		for ( i=0; i<item->NumProperties(); i++ ) {
			item->GetProperty(i, temp);
			AddListItem(temp);
		}
	}

	// ACeĕ`悵܂
	Invalidate();
}
//---------------------------------------------------------------------------

// JX^h[Jn
DWORD CPropListView::OnPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd)
{
	return CDRF_NOTIFYSUBITEMDRAW;
}
//---------------------------------------------------------------------------

// JX^h[ACe`
DWORD CPropListView::OnItemPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd)
{
	return CDRF_NOTIFYSUBITEMDRAW;
}
//---------------------------------------------------------------------------

// JX^h[TuACe`
DWORD CPropListView::OnSubItemPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd)
{
	DWORD cl;
	unsigned int item, sub_item;
	LPNMLVCUSTOMDRAW lpnmlv = reinterpret_cast<LPNMLVCUSTOMDRAW>(lpnmcd);

	item = lpnmlv->nmcd.dwItemSpec;
	sub_item = lpnmlv->iSubItem;

	if ( item<GetItemCount() ) {

		// FĨZ̏ꍇ́AwiFݒ肵܂
		if ( (*this)[ item ].GetEditType(sub_item)==EDIT_COLORDLG ) {
			tstringstream tstrm;
			tstrm.str( (*this)[ item ].GetText(sub_item) );
			tstrm >> std::hex >> cl;
			lpnmlv->clrTextBk = cl;
		}

		// ʏ̃ŹAwi
		else {
			lpnmlv->clrTextBk = RGB(255, 255, 255);
		}
	}

	return CDRF_DODEFAULT;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	FI_CAO
//
//---------------------------------------------------------------------------

// eLXg擾܂
int CColorEdit::GetItemText(WTL::CString& strText) const
{
	tstringstream tstrm;
	tstrm << std::showbase << std::hex << mColor;
	strText = tstrm.str().c_str();
	return strText.GetLength();
}
//---------------------------------------------------------------------------

// ACeҏWJn܂
void CColorEdit::BeginItemEdit(const CRect& rect, LPCTSTR strText, int image)
{
	tstringstream tstrm(strText);

	tstrm >> std::hex >> mColor;
	CColorDialog dlg(mColor);

	if ( dlg.DoModal()==IDOK )
		mColor = dlg.GetColor();

	::SendMessage(mEditorParent, WM_USER_ENDITEMEDIT, NULL, NULL);
}
//---------------------------------------------------------------------------

// _CAO܂
HWND CColorEdit::InitItemEdit(HWND hWndParent)
{
	mEditorParent = hWndParent;
	return hWndParent;
}
//---------------------------------------------------------------------------
