#include "StdAfx.h"
#include "NPortFunction.h"
#include "basic_matrixfunc.h"

#include <boost/numeric/ublas/triangular.hpp>
#include <boost/numeric/ublas/banded.hpp>
#include <boost/numeric/ublas/lu.hpp>
#include <boost/numeric/ublas/io.hpp>


//Cs[_Xϊ܂
void impedance_transform(
	complex_matrix& base, const complex_matrix& z0src, const complex_matrix& z0dest )
{
	using namespace ublas;
	
	unsigned int size = base.size1();
	complex<double> z0d, z0s, g, g_conj;
	double d;

	complex_matrix r = zero_matrix< complex<double> >(size);
	complex_matrix r_conj = zero_matrix< complex<double> >(size);

	complex_matrix a = zero_matrix< complex<double> >(size);
	complex_matrix a_conj = zero_matrix< complex<double> >(size);
	complex_matrix a_inv = zero_matrix< complex<double> >(size);


	//Cs[_XdˌWsAs̎Zo
	for ( unsigned int i=0; i<size; i++ ) {

		//dˌW̎Zo
		z0s = z0src(i, i);
		z0d = z0dest(i, i);
		g = (z0d - z0s) / (z0d + conj(z0s));
		g_conj = conj(g);
		r(i, i) = g;
		r_conj(i, i) = g_conj;

		//As̗vfZo
		a(i, i) = complex<double>(1.0) - g_conj;
		a(i, i) *= sqrt(abs(complex<double>(1.0) - g * g_conj)) / abs(complex<double>(1.0) - g);
		a_conj(i, i) = conj( a(i, i) );
		a_inv(i, i) = complex<double>(1.0) / a(i, i);
	}

	//A̋ts߂܂
	complex_matrix res = identity_matrix< complex<double> >(size) - prod(r, base);
	inverse_matrix(res);

	res = prod(res, a_conj);
	res = prod(base - r_conj, res);
	base = prod(a_inv, res);
}
//---------------------------------------------------------------------------

// Z}gNXS}gNXɕϊ܂
void ZtoSmatrix(complex_matrix& dest)
{
	using namespace ublas;
	complex_matrix ident, temp;

	ident = identity_matrix< complex<double> >(dest.size1());
	temp = dest + ident;
	inverse_matrix(temp);
	dest = prod(temp, dest - ident);
}
//---------------------------------------------------------------------------

// Y}gNXS}gNXɕϊ܂
void YtoSmatrix(complex_matrix& dest)
{
	using namespace ublas;
	complex_matrix ident, temp;

	ident = identity_matrix< complex<double> >(dest.size1());
	temp = ident + dest;
	inverse_matrix(temp);
	dest = prod(temp, ident - dest);
}
//---------------------------------------------------------------------------
