#include "stdafx.h"
#include "MelonDocument.h"
#include "MelonSweep.h"
#include "PropertyForm.h"

// fUCXgύXCxg
void CPropertyForm::OnSelChange(UINT uNotifyCode, int nID, CWindow wndCtl)
{
	GetManager()->GetDocument()->ActivateDesign( mDesignList.GetCurSel() );
	
	// fUCNULL`FbN
	CMelonDesign* design = GetManager()->GetDesign();
	if ( design!=NULL ) {
		GetManager()->UpdateControl(
			CTRL_MATCHLIST |CTRL_SWEEPLIST |CTRL_MARKERLIST);
		GetManager()->UpdatePropList(design->Sweep(0));
	}
}
//---------------------------------------------------------------------------

// hLgeGUIɔf܂
void CPropertyForm::SetDocument(CMelonDocument* doc)
{
	unsigned int i;

	// fUCXg܂
	mDesignList.ResetContent();
	for ( i=0; i<doc->size(); i++ )
		mDesignList.AddItem((*doc)[i]->GetDesignName(), -1, -1, 0);

	mDesignList.SetCurSel( GetManager()->GetDocument()->GetActiveIndex() );
}
//---------------------------------------------------------------------------

// bZ[WtB^
BOOL CPropertyForm::PreTranslateMessage(MSG *pMsg)
{
	if ( pMsg->message==WM_KEYDOWN ) {
		if ( pMsg->wParam==VK_ESCAPE || pMsg->wParam==VK_RETURN )
			return FALSE;
	}

	return CWindow::IsDialogMessage(pMsg);
}
//---------------------------------------------------------------------------

//EChEJnCxg
BOOL CPropertyForm::OnInitDialog(CWindow wndFocus, LPARAM lInitParam)
{
	CMessageLoop* loop = _Module.GetMessageLoop();
	loop->AddMessageFilter(this);

	// _CAOTCY
	DlgResize_Init(true, false);
//	DlgResize_Init(true, true, WS_THICKFRAME | WS_MAXIMIZEBOX | WS_CLIPCHILDREN);


	// WTLIuWFNg̃N
	CRect rect;
	mDesignList = GetDlgItem(IDC_DESIGNLIST);
	mPropertyList.SubclassWindow( GetDlgItem(IDC_PROPLIST) );
	initPropertyList();

	return 0;
}
//---------------------------------------------------------------------------

//EChEjCxg
void CPropertyForm::OnDestroy()
{
	CMessageLoop* loop = _Module.GetMessageLoop();
	loop->RemoveMessageFilter(this);
}
//---------------------------------------------------------------------------

// vpeBXg܂
void CPropertyForm::initPropertyList()
{
	// ̃C[WXg쐬
	CImageList il;
	il.Create(1, 16, ILC_COLOR8 | ILC_MASK, 0, 0);

	// Xgr[
	CRect rect;
	mPropertyList.GetClientRect(&rect);
	mPropertyList.SetExtendedListViewStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	mPropertyList.SetImageList(il, LVSIL_SMALL);
	mPropertyList.SetFont(GetFont(), false);
	
	// ҏWpGfBbg̍쐬
	mPropertyList.AddEditor<CLabelEdit>(EDIT_TEXTBOX);
	mPropertyList.AddEditor<CColorEdit>(EDIT_COLORDLG);
	mPropertyList.InsertColumn(0, _T("item"),	LVCFMT_LEFT, 0.25*rect.Width());
	mPropertyList.InsertColumn(1, _T("value"),	LVCFMT_LEFT, 0.25*rect.Width());
	mPropertyList.InsertColumn(2, _T("unit"),	LVCFMT_LEFT, 0.25*rect.Width());

	// }[J[\LIR{{bNX̏
	CComboEdit* combo_edit = mPropertyList.AddEditor<CComboEdit>(EDIT_DESCLIST);
	combo_edit->AddItem(_T("None")			, -1, -1, 0);
	combo_edit->AddItem(_T("Mag Phase")		, -1, -1, 0);
	combo_edit->AddItem(_T("Impedance")		, -1, -1, 0);
	combo_edit->AddItem(_T("Admittance")	, -1, -1, 0);
}
//---------------------------------------------------------------------------
