#include "stdafx.h"
#include "SmithChart.h"

// vbg֐
void CSmithChart::plot_points(const Gdiplus::Pen* pen, Gdiplus::PointF* points, int count)
{
    // LoXāAOtvbg܂
	mCanvas->DrawLines(pen, points, count);
}
//---------------------------------------------------------------------------

// }[J[`悵܂
void CSmithChart::Mark(
	const Gdiplus::Pen* pen, float radius, const std::complex<double>& val, LPCTSTR name)
{
	// }[J[̃TCYݒ肵܂
	Gdiplus::RectF rect;
	rect.X = mRadius * val.real() - radius;
	rect.Y = -mRadius * val.imag() - radius;
	rect.Width = 2.0f* radius;
	rect.Height = 2.0f* radius;
	
	// eLXg̏o͍Wݒ肵܂
	Gdiplus::PointF pos;
	pos.X = rect.GetRight();
	pos.Y = rect.GetBottom();

	// }[J[`悵܂
	mCanvas->DrawEllipse(pen, rect);

	// }[J[̖O`悵܂
	CT2CW w_name(name);
	mCanvas->DrawString(w_name, wcslen(w_name), mStyle->DefaultFont(), pos, mStyle->BlackBrush());
}
//---------------------------------------------------------------------------

// }Iȉ`悵܂
void CSmithChart::WriteLine(LPCTSTR note)
{
	// s̍肵܂
	float h = mStyle->DefaultFont()->GetHeight(mCanvas);

	Gdiplus::PointF pos;
	pos.X = mRadius + 10.0f;
	pos.Y = -mRadius + h * mLine;

	CT2CW w_note(note);
	mCanvas->DrawString(w_note, wcslen(w_note), mStyle->DefaultFont(), pos, mStyle->BlackBrush());

	// s肵܂
	mLine += 1.0f;
}
//---------------------------------------------------------------------------

// t̖}Iȉ`悵܂
void CSmithChart::WriteLine(const Gdiplus::Pen* pen, LPCTSTR note)
{
	// s̍肵܂
	float h = mStyle->DefaultFont()->GetHeight(mCanvas);

	// o͂܂
	Gdiplus::PointF pos;
	pos.X = mRadius + 40.0f;
	pos.Y = -mRadius + h * mLine;

	CT2CW w_note(note);
	mCanvas->DrawString(w_note, wcslen(w_note), mStyle->DefaultFont(), pos, mStyle->BlackBrush());

	// o͂܂
	pos.X = mRadius + 10.0f;
	pos.Y = -mRadius + h * (mLine + 0.5f);
	mCanvas->DrawLine(pen, pos.X, pos.Y, pos.X+30.0f, pos.Y);

	// s肵܂
	mLine += 1.0f;
}
//---------------------------------------------------------------------------

// s肵܂
void CSmithChart::VSpace(float line)
{
	mLine += line;
}
//---------------------------------------------------------------------------

// OtGA܂
void CSmithChart::Clear()
{
	// s߂܂
	mLine = 0.0f;

    //LoXāAhԂ܂
	mCanvas->Clear(Gdiplus::Color::White);
    mCanvas->DrawLine(mStyle->ImpGrid(), -mRadius, 0.0f, mRadius, 0.0f);

	// Cs[_X`[g̕`
	CSmithStyle::const_grid_iterator it;
	if ( mStyle->IsFormat(STYLE_IMPGRID) ) {

		// WX^X~̕`
		for ( it=mStyle->FirstRGrid(); it!=mStyle->LastRGrid(); it++ )
			draw_RGrid( *it, mStyle->IsFormat(STYLE_IMPTICK) );

		// AN^X̕`
		for ( it=mStyle->FirstXGrid(); it!=mStyle->LastXGrid(); it++ )
			draw_XGrid( *it, mStyle->IsFormat(STYLE_IMPTICK) );
	}
	
	// Ah~^X`[g̕`
	if ( mStyle->IsFormat(STYLE_ADMGRID) ) {
		
		// R_N^X~̕`
		for ( it=mStyle->FirstGGrid(); it!=mStyle->LastGGrid(); it++ )
			draw_GGrid( *it, mStyle->IsFormat(STYLE_ADMTICK) );

		// TZv^X̕`
		for ( it=mStyle->FirstBGrid(); it!=mStyle->LastBGrid(); it++ )
			draw_BGrid( *it, mStyle->IsFormat(STYLE_ADMTICK) );
	}
}
//---------------------------------------------------------------------------

// AN^X`悵܂
void CSmithChart::draw_XGrid(double z, bool tick)
{
	using namespace std;
	float r, phi;

	r = mRadius / z;
	phi = 360.0 * atan(z) / M_PI;

	if ( z>0 )
		mCanvas->DrawArc(mStyle->ImpGrid(), mRadius-r, -2*r, 2*r, 2*r, 90, phi);
	else
		mCanvas->DrawArc(mStyle->ImpGrid(), mRadius+r, 0.0, -2*r, -2*r, 270, phi);

	if ( tick ) {

		// ڐ̕`WvZ܂
		Gdiplus::PointF pos;
		phi = 2.0 * atan(z);
		pos.X = mRadius - r * sin(phi);
		pos.Y = r * (cos(phi) - 1.0);

		// ڐ`悵܂
		wstringstream wstrm;
		wstrm << z;
		mCanvas->DrawString(
			wstrm.str().c_str(), wstrm.str().length(), mStyle->DefaultFont(), pos, mStyle->TextBrush());
	}
}
//---------------------------------------------------------------------------

// WX^X~`悵܂
void CSmithChart::draw_RGrid(double z, bool tick)
{
	using namespace std;
	float r, x;
	r = mRadius / (z + 1.0);
	x = z * r - r;

	mCanvas->DrawArc(mStyle->ImpGrid(), x, -r, 2*r, 2*r, 0, 360);

	if ( tick ) {

		// ڐ̍Wݒ肵܂
		Gdiplus::PointF pos;
		pos.X = x;
		pos.Y = 0;

		// ڐ`悵܂
		wstringstream wstrm;
		wstrm << z;
		mCanvas->DrawString(
			wstrm.str().c_str(), wstrm.str().length(), mStyle->DefaultFont(), pos, mStyle->TextBrush());
	}
}
//---------------------------------------------------------------------------

// TZv^X`悵܂
void CSmithChart::draw_BGrid(double y, bool tick)
{
	using namespace std;
	float r, phi;

	r = mRadius / y;
	phi = 360.0 * atan(y) / M_PI;

	if ( y>0 )
		mCanvas->DrawArc(mStyle->AdmGrid(), -mRadius-r, -2*r, 2*r, 2*r, 90, -phi);
	else
		mCanvas->DrawArc(mStyle->AdmGrid(), -mRadius+r, 0.0, -2*r, -2*r, 270, -phi);
	
	if ( tick ) {

		// ڐ̕`WvZ܂
		Gdiplus::PointF pos;
		phi = 2.0 * atan(y);
		pos.X = r * sin(phi) - mRadius;
		pos.Y = r * (1.0 - cos(phi));

		// ڐ`悵܂
		wstringstream wstrm;
		wstrm << y;
		mCanvas->DrawString(
			wstrm.str().c_str(), wstrm.str().length(), mStyle->DefaultFont(), pos, mStyle->TextBrush());
	}
}
//---------------------------------------------------------------------------

// R_N^X~`悵܂
void CSmithChart::draw_GGrid(double y, bool tick)
{
	using namespace std;
	float r;
	r = mRadius / (y + 1.0);

	mCanvas->DrawArc(mStyle->AdmGrid(), -mRadius, -r, 2*r, 2*r, 0, 360);
	
	if ( tick ) {

		// ڐ̍Wݒ肵܂
		Gdiplus::PointF pos;
		pos.X = 2.0 * r - mRadius;
		pos.Y = 0;

		// ڐ`悵܂
		wstringstream wstrm;
		wstrm << y;
		mCanvas->DrawString(
			wstrm.str().c_str(), wstrm.str().length(), mStyle->DefaultFont(), pos, mStyle->TextBrush());
	}
}
//---------------------------------------------------------------------------

// RXgN^
CSmithChart::CSmithChart(Gdiplus::Graphics* g, CSmithStyle* style)
	: mCanvas(g), mStyle(style), mRadius(style->GetRadius())
{
}
//---------------------------------------------------------------------------
