#pragma once
#include "SmithStyle.h"


//---------------------------------------------------------------------------
//
//	X~X`[gNX
//
//---------------------------------------------------------------------------
class CSmithChart
{
public:
	typedef std::vector<Gdiplus::PointF> point_array;
	typedef point_array::iterator point_iterator;
	typedef point_array::const_iterator const_point_iterator;

private:
	float	mLine;
	double	mRadius;
	CSmithStyle*		mStyle;
	Gdiplus::Graphics*	mCanvas;

	// Obh`
	void draw_RGrid(double z, bool tick);
	void draw_XGrid(double z, bool tick);
	void draw_GGrid(double y, bool tick);
	void draw_BGrid(double y, bool tick);

	// vbg֐
	void plot_points(const Gdiplus::Pen* pen, Gdiplus::PointF* points, int count);

public:
	// RXgN^ƃfXgN^
	CSmithChart(Gdiplus::Graphics* g, CSmithStyle* style);
	virtual ~CSmithChart(){}
	
	// Oẗ܂
	void Clear();
	
	// }[J[`悵܂
	void Mark(const Gdiplus::Pen* pen, float radius, const std::complex<double>& val, LPCTSTR name);

	// }Iȉ`悵܂
	void WriteLine(LPCTSTR note);
	void WriteLine(const Gdiplus::Pen* pen, LPCTSTR note);
	void VSpace(float line);
	
	// dˌWvbg܂
	template<class _iterator>
	void Plot(const Gdiplus::Pen* pen, _iterator first, _iterator last)
	{
		using namespace std;
		point_array points( distance(first, last) );
		
		// Wϊ[v
		_iterator it = first;
		point_iterator pt = points.begin();
		for ( ; it!=last; it++, pt++ ) {
			pt->X = it->real() * mRadius;
			pt->Y = -it->imag() * mRadius;
		}

		// Ot̕`
		plot_points(pen, &points.front(), points.size());
	}
};
