#include "stdafx.h"
#include "ListItem.h"
#include "SmithStyle.h"

// vpeBύX܂
void CBasicSmithStyle::SetProperty(int index, IListItem& item)
{
	bool bl;
	double d;
	DWORD set, clr;
	Gdiplus::Color color;

	switch ( index ) {
		case 0:
			if ( GetVariable(item, d) ) mImpGrid->SetWidth(d);
			break;

		case 1:
			if ( GetVariable(item, color) ) mImpGrid->SetColor(color);
			break;

		case 2:
			if ( GetVariable(item, d) ) mAdmGrid->SetWidth(d);
			break;

		case 3:
			if ( GetVariable(item, color) ) mAdmGrid->SetColor(color);
			break;

		case 4:
			if ( GetVariable(item, bl) ) SetFormat(STYLE_IMPGRID, bl);
			break;

		case 5:
			if ( GetVariable(item, bl) ) SetFormat(STYLE_ADMGRID, bl);
			break;

		case 6:
			if ( GetVariable(item, bl) ) SetFormat(STYLE_IMPTICK, bl);
			break;

		case 7:
			if ( GetVariable(item, bl) ) SetFormat(STYLE_ADMTICK, bl);
			break;
	}
}
//---------------------------------------------------------------------------

// vpeB擾܂
void CBasicSmithStyle::GetProperty(int index, IListItem& item)
{
	double d;
	Gdiplus::Color color;

	switch ( index ) {
		case 0:
			item.SetText(0, _T("ImpGridWidth"));
			SetItem(item, mImpGrid->GetWidth());
			break;

		case 1:
			item.SetText(0, _T("ImpGridColor"));
			mImpGrid->GetColor(&color);
			SetItem(item, color);
			break;

		case 2:
			item.SetText(0, _T("AdmGridWidth"));
			SetItem(item, mAdmGrid->GetWidth());
			break;

		case 3:
			item.SetText(0, _T("AdmGridColor"));
			mAdmGrid->GetColor(&color);
			SetItem(item, color);
			break;

		case 4:
			item.SetText(0, _T("ImpGrid"));
			SetItem(item, (bool)(mFormat & STYLE_IMPGRID));
			break;

		case 5:
			item.SetText(0, _T("AdmGrid"));
			SetItem(item, (bool)(mFormat & STYLE_ADMGRID));
			break;

		case 6:
			item.SetText(0, _T("ImpTick"));
			SetItem(item, (bool)(mFormat & STYLE_IMPTICK));
			break;

		case 7:
			item.SetText(0, _T("AdmTick"));
			SetItem(item, (bool)(mFormat & STYLE_ADMTICK));
			break;
	}
}
//---------------------------------------------------------------------------

// ỹvpeB擾܂
void CBasicSmithStyle::get_pen_property(Gdiplus::Pen* pen, IListItem& item)
{
}
//---------------------------------------------------------------------------

//RXgN^
CBasicSmithStyle::CBasicSmithStyle()
{
	float dash[] = {1.0f, 1.0f};

	mBoldGrid = new Gdiplus::Pen(Gdiplus::Color::Gray, 1.5f);
	mImpGrid = new Gdiplus::Pen(Gdiplus::Color::Gray, 0.5f);
	mAdmGrid = new Gdiplus::Pen(Gdiplus::Color::Gray, 0.5f);

	mTextBrush = new Gdiplus::SolidBrush(Gdiplus::Color::DarkGray);
	mBlackBrush = new Gdiplus::SolidBrush(Gdiplus::Color::Black);
	mWhiteBrush = new Gdiplus::SolidBrush(Gdiplus::Color::White);
	mDefaultFont = new Gdiplus::Font(L"Times New Roman", 10.0f);

	// Obh܂
	init_GridList();
}
//---------------------------------------------------------------------------

//fXgN^
CBasicSmithStyle::~CBasicSmithStyle()
{
	delete mBoldGrid;
	delete mImpGrid;
	delete mAdmGrid;
	delete mBlackBrush;
	delete mWhiteBrush;
	delete mTextBrush;
	delete mDefaultFont;
}
//---------------------------------------------------------------------------

// Obh܂
void CBasicSmithStyle::init_GridList()
{
	// WX^X~̐ݒ
	mRGrid.push_back(0);
	mRGrid.push_back(0.2);
	mRGrid.push_back(0.5);
	mRGrid.push_back(1);
	mRGrid.push_back(2);
	mRGrid.push_back(5);

	// AN^X̐ݒ
	mXGrid.push_back(-5);
	mXGrid.push_back(-2);
	mXGrid.push_back(-1);
	mXGrid.push_back(-0.5);
	mXGrid.push_back(-0.2);
	mXGrid.push_back(0.2);
	mXGrid.push_back(0.5);
	mXGrid.push_back(1);
	mXGrid.push_back(2);
	mXGrid.push_back(5);

	// R_N^X~̐ݒ
	mGGrid.push_back(0);
	mGGrid.push_back(0.2);
	mGGrid.push_back(0.5);
	mGGrid.push_back(1);
	mGGrid.push_back(2);
	mGGrid.push_back(5);

	// TZv^X̐ݒ
	mBGrid.push_back(-5);
	mBGrid.push_back(-2);
	mBGrid.push_back(-1);
	mBGrid.push_back(-0.5);
	mBGrid.push_back(-0.2);
	mBGrid.push_back(0.2);
	mBGrid.push_back(0.5);
	mBGrid.push_back(1);
	mBGrid.push_back(2);
	mBGrid.push_back(5);
}
//---------------------------------------------------------------------------

// tH[}bgݒ肵܂
void CSmithStyle::SetFormat(DWORD style, bool sw)
{
	if ( sw )
		mFormat |= style;
	else
		mFormat &= ~style;
}
//---------------------------------------------------------------------------

