#include "stdafx.h"
#include "SmithChart.h"
#include "MelonDocument.h"
#include "MatchingElem.h"
#include "MelonSweep.h"
#include "SmithWindow.h"

// `Cxg
void CSmithWindow::OnPaint(WTL::CDCHandle)
{
	PAINTSTRUCT ps;

	// obt@Rs[܂
    HDC hdc = BeginPaint(&ps);
	mCanvas.StretchBlt(hdc, 0, 0, SRCCOPY);
    EndPaint(&ps);
}
//---------------------------------------------------------------------------

// EChETCYύXCxg
void CSmithWindow::OnSize(UINT nType, CSize size)
{
	CRect rect;
	GetClientRect(&rect);
	mCanvas.SetSize(rect.Width(), rect.Height());
	mCanvas.Clear(0xffffff);
	
	// ϊsXV܂
	double pos = min(rect.Width()/1.2, rect.Height());
	mTransform->Reset();
	mTransform->Translate(0.5*pos, 0.5*rect.Height(), Gdiplus::MatrixOrderAppend);

	// X~X`[gĕ`悵܂
	GetManager()->GetStyle()->SetRadius(0.45 * pos);
	GetManager()->UpdateSmithChart();
}
//---------------------------------------------------------------------------

// bZ[WtB^
BOOL CSmithWindow::PreTranslateMessage(MSG *pMsg)
{
	return FALSE;
}
//---------------------------------------------------------------------------

// hbOhbvt@CCxg
void CSmithWindow::OnDropFiles(HDROP hDropInfo)
{
	int count = DragQueryFile(hDropInfo, 0xffffffff, NULL, 0);

	if ( count>0 ) {
		
		TCHAR path[1024];
		DragQueryFile(hDropInfo, 0, path, 1024);

		// fUC𐶐
		WTL::CString name(path);
		CMelonDesign* design = new CMelonDesign( new CNPortTerminal(name, 0) );

		// fUC
		int pos = name.ReverseFind(_T('\\'));
		name.Delete(0, pos + 1);
		design->SetDesignName(name);

		// fUChLgɒǉčĕ`
		GetManager()->GetDocument()->AddDesign(design);
		GetManager()->UpdateControl(
			CTRL_MATCHLIST |CTRL_SWEEPLIST |CTRL_MARKERLIST |CTRL_DESIGNLIST |CTRL_SMITHCHART);
		GetManager()->UpdatePropList(design->Sweep(0));
	}
}
//---------------------------------------------------------------------------

//EChEJnCxg
int CSmithWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	CMessageLoop* loop = _Module.GetMessageLoop();
	loop->AddMessageFilter(this);

	// obNobt@̏
	CRect rect;
	GetClientRect(&rect);
	GetManager()->GetStyle()->SetRadius(0.4 * rect.Width());
	mCanvas.SetSize(rect.Width(), rect.Height());

	// ϊsXV܂
	mTransform = new Gdiplus::Matrix();
	mTransform->Reset();
	mTransform->Translate(0.5*rect.Width(), 0.5*rect.Height(), Gdiplus::MatrixOrderAppend);

	DragAcceptFiles(TRUE);

	return 0;
}
//---------------------------------------------------------------------------

//EChEjCxg
void CSmithWindow::OnDestroy()
{
	// ϊs̔j
	delete mTransform;

	CMessageLoop* loop = _Module.GetMessageLoop();
	loop->RemoveMessageFilter(this);
}
//---------------------------------------------------------------------------

