#include "StdAfx.h"
#include "TouchStone.h"
#include "NPortFunction.h"
#include <strstream>
#include <boost/algorithm/string.hpp>


//gɑΉf[^擾܂
complex_matrix& CNPortData::Interpolate(complex_matrix& mat, double freq) const
{
	size_type n;
	double l, u;
	CSolution::const_iterator lo, up;
	const CSolution& sol( *pSolution );


	//w肳ꂽg̃f[^݂ꍇ́Â܂܏o
	mat.resize(mNumPorts, mNumPorts);
	lo = find(sol.begin(), sol.end(), freq);
	n = distance(sol.begin(), lo);
	if ( lo!=sol.end() )
		mat = *(mData.begin() + n);

	// f[^Ȃ̏ꍇ́APʍsԂ܂
	else if ( mData.size()==0 )
		mat = ublas::identity_matrix< complex<double> >(mNumPorts);

	// f[^̏ꍇ͂Ԃ܂
	else if ( mData.size()==1 )
		mat = mData.back();

	// ȊȌꍇ́A}ďo
	else {
		
		lo = upper_bound(sol.begin(), sol.end(), freq);
		up = lower_bound(sol.begin(), sol.end(), freq);
		if ( lo==sol.end() )
			mat = mData.front();

		else if ( up==sol.end() )
			mat = mData.back();

		else {
			// vZ܂
			n = distance(sol.begin(), lo);
			u = sol[n + 1] - sol[n];
			l = (freq - sol[n]) / u;
			u = (sol[n + 1] - freq) / u;

			// }f[^vZ܂
			mat = u * mData[n] + l * mData[n + 1];
		}
	}

	return mat;
}
//---------------------------------------------------------------------------

// \[Vf[^ݒ肵āANPortf[^ČvZ܂
void CNPortData::SetSolution(SolutionPtr sol)
{
	using namespace std;
	vector<complex_matrix> mat_array;
	complex_matrix mat(mNumPorts, mNumPorts);
	CSolution::iterator it;

	// ԃf[^vZ܂
	for ( it=sol->begin(); it!=sol->end(); it++ ) {

		Interpolate(mat, *it);
		mat_array.push_back(mat);
	}

	// f[^Rs[܂
	pSolution = sol;
	mData.clear();
	copy(mat_array.begin(), mat_array.end(), back_inserter(mData));
}
//---------------------------------------------------------------------------

// NPortf[^[h܂
void CNPortData::import_data(const WTL::CString& path)
{
	using namespace std;
	WTL::CString temp(path);

	// f[^܂
	clear();

	//ɕϊĊgq𒊏o
	temp.MakeLower();
	int pos = temp.ReverseFind(_T('.'));


	//|[g̃`FbN
	temp.Delete(0, ++pos);
	mNumPorts = 0;
	mNumPorts = _ttoi( (LPCTSTR)temp + 1 );
	if ( temp[0]!=_T('s') || mNumPorts==0 ) return;


	double hz, ref;
    char desc;
	string buff;
	ifstream ifs( (LPCTSTR)path, ios::in );

	//tH[}bgʎq܂ŃXLbv
	while ( ifs.peek()!='#' ) {
		ifs.ignore(1000, '\n');
		if ( ifs.eof() ) return;
	}


	//gPʂ擾
	char ch;
	ifs.get();
	ifs >> ch;
	ifs.unget();
	getline(ifs, buff, ' ');
	hz = get_frequency_unit(buff);

	// S/Z/Ys𔻕
	ifs >> ch;
	ifs.unget();
	getline(ifs, buff, ' ');
	mParamType = buff[0];

	//f\`̎擾
	ifs >> ch;
	ifs.unget();
	getline(ifs, buff, ' ');
	desc = buff[0];

	//Cs[_X̎擾
	ifs >> ch >> ch;
	ifs.unget();
	ifs >> ref;
	if ( mParamType=='S' ) ref = 1.0;


	//NPortf[^̃C|[g
	switch ( desc ) {
		case 'R':
		import_data(ifs, hz, formatRI(1.0));
		break;

		case 'M':
		import_data(ifs, hz, formatMA(1.0));
		break;

		case 'D':
		import_data(ifs, hz, formatDB(ref));
		break;
	}
}
//---------------------------------------------------------------------------

//NPortf[^̃C|[g
void CNPortData::import_data( istream& ifs, double hz, nport_fmt& cvt )
{
	double freq, x, y, prev(0);
	complex_matrix mx(mNumPorts, mNumPorts);
	CSolution::iterator it;

	// f[^̏
	clear();

	// f[^ǂݏo[v
	char ch;
	while (1) {

		// RgsXLbv܂
		ifs.clear();
		ifs >> ch;
		if ( ifs.eof() ) break;
		else if ( !isdigit(ch) ) {
			ifs.ignore(1000, '\n');
			continue;
		}
		ifs.unget();

		// gǂݍ݂܂
		ifs >> freq;
		freq *= hz;

		// 1|[g̏ꍇ
		if ( mNumPorts==1 ) {
			ifs >> x >> y;
			cvt(x, y, mx(0,0));
		}

		// 2|[gȉ̏ꍇ
		else if ( mNumPorts==2 ) {
		
			ifs >> x >> y;
			cvt(x, y, mx(0,0));
		
			ifs >> x >> y;
			cvt(x, y, mx(1,0));

			ifs >> x >> y;
			cvt(x, y, mx(0,1));

			ifs >> x >> y;
			cvt(x, y, mx(1,1));
		}

		// 3|[gȏ̏ꍇ
		else {

			for ( int k=0; k<mNumPorts; k++ ) {
				for ( int i=0; i<mNumPorts; i++ ) {

					ifs >> x >> y;
					cvt(x, y, mx(k,i));
				}
			}
		}

		// g\[gĂȂꍇ́A\[g܂
		if ( prev>freq ) {
			it = lower_bound(pSolution->begin(), pSolution->end(), freq);
			if ( it!=pSolution->end() )
				mData.insert(mData.begin() + distance(pSolution->begin(), it), mx);
			else
				mData.push_back(mx);
			pSolution->insert(it, freq);
		}

		// \[VɃf[^ǉ
		else {
			mData.push_back(mx);
			pSolution->push_back(freq);
		}
		prev = freq;
	}
}
//---------------------------------------------------------------------------

//gPʂ̕ϊ
double CNPortData::get_frequency_unit( string fmt )
{
	double res;

	transform(fmt.begin(), fmt.end(), fmt.begin(), toupper);

	switch ( fmt[0] ) {

		case 'H':
		res = 1.0;
		break;

		case 'K':
		res = 1.0e+3;
		break;

		case 'M':
		res = 1.0e+6;
		break;

		case 'G':
		res = 1.0e+9;
		break;

		case 'T':
		res = 1.0e+12;
		break;

		case 'P':
		res = 1.0e+15;
		break;

		default:
		res = 1.0;
	}

	return res;
}
//---------------------------------------------------------------------------

//f[^t@Cɏo͂܂
void CNPortData::export_data(const WTL::CString& path)
{
	using namespace std;
	ofstream ofs( (LPCTSTR)path, ios::out);

	//o̓tH[}bgƃwb_ݒ肵܂
	ofs.setf(ios::scientific);
	ofs.precision(15);
	ofs << "! Exported from SparamP01\n";
	ofs << "# GHZ S MA R 50.000000\n";

	
	//ׂĂ̎go͂܂
	const_iterator it = mData.begin();
	CSolution::const_iterator freq = pSolution->begin();
	for ( ; it!=mData.end(); it++, freq++ ) {
		
		ofs << (*freq) * 1.0e-9;
		for ( int k=0; k<mNumPorts; k++ ) {

			for ( int i=0; i<mNumPorts; i++ ) {

				ofs << " " << abs((*it)(k,i));
				ofs << " " << arg((*it)(k,i)) * (180.0 / M_PI);

				if ( i==mNumPorts-1 )
					ofs << "\n";
				else if ( i%4==3 )
					ofs << "\n    ";
			}
		}
	}
}
//---------------------------------------------------------------------------

//gˑ̊Cs[_Xϊ
bool CNPortData::Z0transform(const CNPortData& z0src, const CNPortData& z0dest)
{
	complex_matrix zs(mNumPorts, mNumPorts), zd(mNumPorts, mNumPorts);

	// \[Vf[^قȂꍇ̓LZ
	if ( pSolution!=z0src.pSolution || pSolution!=z0dest.pSolution ) return false;

	
	// gɃCs[_Xϊs܂
	const_iterator src = z0src.begin();
	const_iterator dest = z0dest.begin();
	for ( iterator it=mData.begin(); it!=mData.end(); it++, src++, dest++ ) {

		diagonalStoZ0(zs, *src, 50);
		diagonalStoZ0(zd, *dest, 50);
		impedance_transform(*it, zs, zd);
	}
	return true;
}
//---------------------------------------------------------------------------

// 萔Cs[_Xgˑ̊Cs[_Xɕϊ܂
bool CNPortData::Z0transform(const complex_matrix& z0src, const CNPortData& z0dest)
{
	complex_matrix zd(mNumPorts, mNumPorts);

	// \[Vf[^قȂꍇ̓LZ
	if ( pSolution!=z0dest.pSolution ) return false;

	
	// gɃCs[_Xϊs܂
	const_iterator dest = z0dest.begin();
	for ( iterator it=mData.begin(); it!=mData.end(); it++, dest++ ) {

		diagonalStoZ0(zd, *dest, 50);
		impedance_transform(*it, z0src, zd);
	}
	return true;
}
//---------------------------------------------------------------------------

// gˑ̊Cs[_X萔Cs[_Xɕϊ܂
bool CNPortData::Z0transform(const CNPortData& z0src, const complex_matrix& z0dest)
{
	complex_matrix zs(mNumPorts, mNumPorts);

	// \[Vf[^قȂꍇ̓LZ
	if ( pSolution!=z0src.pSolution ) return false;

	
	// gɃCs[_Xϊs܂
	const_iterator src = z0src.begin();
	for ( iterator it=mData.begin(); it!=mData.end(); it++, src++ ) {

		diagonalStoZ0(zs, *src, 50);
		impedance_transform(*it, zs, z0dest);
	}
	return true;
}
//---------------------------------------------------------------------------

// 萔Cs[_XsŊCs[_Xϊs܂
bool CNPortData::Z0transform(const complex_matrix& z0src, const complex_matrix& z0dest)
{
	for ( iterator it=mData.begin(); it!=mData.end(); it++ )
		impedance_transform(*it, z0src, z0dest);

	return true;
}
//---------------------------------------------------------------------------

// S}gNXɕϊ܂
void CNPortData::ToSmatrix()
{
	switch ( mParamType ) {
		case 'Z':
			std::for_each(mData.begin(), mData.end(), ZtoSmatrix);
			break;

		case 'Y':
			std::for_each(mData.begin(), mData.end(), YtoSmatrix);
			break;
	}
}
//---------------------------------------------------------------------------

//Cs[_XΊpsSp[^琶܂
void CNPortData::diagonalStoZ0(complex_matrix &dest, const complex_matrix &s, double z0)
{
	complex<double> ident(1.0);
	dest = ublas::identity_matrix<>(s.size1());
	for ( unsigned int i=0; i<s.size1(); i++ ) {
		dest(i, i) = complex<double>(z0) * (ident + s(i, i)) / (ident - s(i, i));
	}
}
//---------------------------------------------------------------------------

//]u܂
void CNPortData::conj_trans()
{
	iterator it;

	for ( it=mData.begin(); it!=mData.end(); it++ )
		conj_matrix(*it);
}
//---------------------------------------------------------------------------

//}gNX܂
bool CNPortData::compose(int pos, const CNPortData &nport)
{
	int i, j, x, y;
	
	// \[Vf[^قȂꍇ̓LZ
	if ( pSolution!=nport.pSolution ) return false;
	
	iterator dest = mData.begin();
	const_iterator src = nport.begin();
	for ( ; dest!=mData.end(); src++, dest++ ) {

		//Yvfɑ܂
		for ( i=0; i<nport.NumPorts(); i++ ) {
			for ( j=0; j<nport.NumPorts(); j++ ) {

				x = (pos + i) % mNumPorts;
				y = (pos + j) % mNumPorts;
				(*dest)(x, y) = (*src)(i, j);
			}
		}
	}
	return true;
}
//---------------------------------------------------------------------------

//|[gւč
bool CNPortData::compose(int pos, const CNPortData& nport, const swap_matrix& adapter)
{
	int i, j, x, y;

	// \[Vf[^قȂꍇ̓LZ
	if ( pSolution!=nport.pSolution ) return false;

	iterator dest = mData.begin();
	const_iterator src = nport.begin();
	for ( ; dest!=mData.end(); src++, dest++ ) {

		//Yvfɑ܂
		for ( i=0; i<adapter.size(); i++ ) {
			for ( j=0; j<adapter.size(); j++ ) {

				x = (pos + i) % mNumPorts;
				y = (pos + j) % mNumPorts;
				(*dest)(x, y) = adapter(*src)(i, j);
			}
		}
	}
	return true;
}
//---------------------------------------------------------------------------

// f[^܂
void CNPortData::clear()
{
	mData.clear();
	pSolution = SolutionPtr(new CSolution);
}
//---------------------------------------------------------------------------

//RXgN^
CNPortData::CNPortData(int num_ports)
{
	pSolution = SolutionPtr(new CSolution);
	mNumPorts = num_ports;
}
//---------------------------------------------------------------------------

//NPortf[^̃RXgN^
CNPortData::CNPortData(const WTL::CString& path)
{
	pSolution = SolutionPtr(new CSolution);
	import_data(path);
}
//---------------------------------------------------------------------------

//Rs[RXgN^
CNPortData::CNPortData(const CNPortData& nport)
{
	operator=(nport);
}
//---------------------------------------------------------------------------

//|[gւă[h
CNPortData::CNPortData(const CNPortData& nport, const swap_matrix& adapter)
{
	mNumPorts = adapter.size();
	mParamType = nport.ParamType();
	pSolution = nport.pSolution;
	mData.clear();

	// vf̃Rs[
	for ( const_iterator it=nport.begin(); it!=nport.end(); it++ )
		mData.push_back( adapter(*it) );
}
//---------------------------------------------------------------------------

//IuWFNgRs[܂
CNPortData& CNPortData::operator =(const CNPortData &nport)
{
	mNumPorts = nport.NumPorts();
	mParamType = nport.ParamType();
	pSolution = nport.pSolution;
	mData.clear();
	copy(nport.begin(), nport.end(), back_inserter(mData));

	return *this;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
//	\[Vf[^NX
//
//---------------------------------------------------------------------------

//RXgN^
CSolution::CSolution(double start, double stop, double step)
{
	for ( ; start<=stop; start++ )
		mSweep.push_back(start);
}
//---------------------------------------------------------------------------
